<?php





class FetchCookie extends BaseObject {
 
 var $name;
 var $value;
 var $expire;
 var $path;
 var $domain;
 var $secure;
 var $httponly;
 
 function FetchCookie($name, $value, $expire="", $path="", $domain="", $secure=false, $httponly=false) {
 $this->name = $name;
 $this->value = $value;
 $this->expire = $expire;
 $this->path = $path;
 $this->domain = $domain;
 $this->secure = $secure;
 $this->httponly = $httponly;
 }

 function getName() {
 return $this->name;
 }

 function getValue() {
 return $this->value;
 }

 function getExpire() {
 return $this->expire;
 }

 function getPath() {
 return $this->path;
 }

 function getDomain() {
 return $this->domain;
 }

 function isSecure() {
 return $this->secure;
 }

 function isHttpOnly() {
 return $this->httponly;
 }

 function setValue($value) {
 $this->value = $value;
 }

 function setPath($path) {
 $this->path = $path;
 }
 
 function setExpire($expire) {
 $this->expire = $expire;
 }

 function setDomain($domain) {
 $this->domain = $domain;
 }

 function setSecure($secure) {
 $this->secure = $secure;
 }

 function setHttpOnly($httponly) {
 $this->httponly = $httponly;
 }

 function matchUrl($url) {
 $parts = parse_url($url);
 
 if ($this->domain != "") {
 $l = strlen($parts["host"]);
 if (!($this->domain == $parts["host"] || substr($parts["host"], -($l+1)) == ".".$this->domain)) return false;
 }
 
 if ($this->path != "") {
 if (substr($parts["path"], 0, strlen($this->path)) != $this->path) return false;
 }
 
 if ($this->secure) {

 }
 
 return true;
 }

 function isExpired($time = false) {
 if (!$time) $time = time();
 
 return false;
 }
}


class fetchurl extends BaseObject {
 
 var $URL = "";
 var $Content = "";
 var $Type = "";
 var $PostVars = array();
 var $Headers = array();
 var $receiveHeaders = array();
 var $receiveHeader = "";
 var $receiveCookies = array();
 var $cookies = array();
 var $PostData = "";
 var $handleCookies = false;
 
 var $error = "";

 
 function fetchurl($type = "get") {

 $this->setSubmitType($type);
 $this->URL = "";
 $this->reset();
 }

 
 function setUrl($value) {
 $this->URL = $value;
 }

 function setSubmitType($value) {
 $value = strtoUpper($value);
 if ($value == "GET" || $value == "POST") {
 $this->Type = $value;
 }
 }

 function setPostData($value) {
 $this->PostData = $value;
 }

 function getUrl() {
 return $this->URL;
 }

 function getSubmitType() {
 return $this->Type;
 }

 function getPostData() {
 return $this->PostData;
 }

 function getError() {
 return $this->error;
 }

 function doHandleCookies() {
 return $this->handleCookies;
 }

 function setHandleCookies($handle) {
 $this->handleCookies = $handle;
 }
 
 
 function getPostVars() {
 return $this->PostVars;
 }

 function setPostVar($var, $value) {
 $oldval = $this->PostVars[(string)$var];
 if (is_array($oldval)) {
 $oldval[] = $value;
 $this->PostVars[(string) $var] = $oldval;
 } else if ($oldval) {
 $this->PostVars[(string) $var] = array($oldval, $value);
 } else {
 $this->PostVars[(string) $var] = $value;
 }
 }

 function getPostVar($var) {
 return $this->PostVars[(string) $var];
 }
 
 function unsetPostVar($var) {
 unset($this->PostVars[(string) $var]);
 }

 function clearPostVars() {
 $this->PostVars = array();
 }

 
 function getHeaders() {
 return $this->Headers;
 }

 function setHeader($var, $value) {
 $this->Headers[(string) $var] = $value;
 }

 function getHeader($var) {
 return $this->Headers[(string) $var];
 }
 
 function unsetHeader($var) {
 unset($this->Headers[(string) $var]);
 }

 function clearHeaders() {
 $this->Headers = array();
 }

 
 function getReceivedHeaders() {
 return $this->receiveHeaders;
 }

 function getReceivedHeader($name) {
 return $this->receiveHeaders[$name];
 }

 function getContent() {
 return $this->Content;
 }

 function getReturnCode() {
 if (ereg("^HTTP/[0-9.]+ ([0-9]+)", $this->receiveHeader, $regs)) {
 return $regs[1];
 }
 return false;
 }

 

 function clearCookies() {
 $this->cookies = array();
 }
 
 function getCookies() {
 return $this->cookies;
 }

 function getCookie($name) {
 return $this->cookies[$name];
 }

 function setCookie($cookie) {
 if (!is_a($cookie, "FetchCookie")) return false;
 $this->cookies[$cookie->getName()] = $cookie;
 return true;
 }
 
 function getReceivedCookies() {
 return $this->receivedCookies;
 }

 function getReceivedCookie($name) {
 return $this->receivedCookies[$name];
 }
 
 

 function reset($cookies = false) {
 $this->Content = "";
 $this->PostVars = array();
 $this->Headers = array();
 $this->receiveHeaders = array();
 $this->PostData = "";
 $this->receiveHeader = "";
 $this->receivedCookies = array();
 if ($cookies) {
 $this->cookies = array();
 }
 }
 
 
 function sendRequest($url = "") {
 
 if ($url) $this->setUrl($url);
 
 $this->receiveHeaders = array();
 $this->receiveHeader = "";
 $this->receiveCookies = array();
 $this->Content = "";
 
 $this->_setCookieHeader();
 
 $this->Content = $this->doRequest();
 
 $this->_loadCookieHeader();
 
 return $this->Content;
 }

 
 
 function doRequest() {
 }


 function _setCookieHeader() {
 $url = $this->getUrl();

 $cookies = "";
 
 foreach ($this->cookies as $cookie) {
 if ($cookie->matchUrl($url) && !$cookie->isExpired()) {
 if ($cookies) $cookies .= "; ";
 $cookies .= $cookie->getName()."=".$cookie->getValue();
 }
 }

 if ($cookies) {
 $this->setHeader("Cookie", $cookies);
 }
 }
 
 function _loadCookieHeader() {

 $cookies = $this->getReceivedHeader("Set-Cookie");
 if ( is_array($cookies) ) {
 foreach ($cookies as $cookie) {
 $this->_parseCookieHeader($cookie);
 }
 }
 
 if ($this->handleCookies) {
 foreach ($this->receivedCookies as $cookie) {
 $this->setCookie($cookie);
 }
 }
 }

 function _parseCookieHeader($header) {
 
 $parts = explode(";", $header);

 $cookies = array();
 $path = "";
 $expire = "";
 $secure = false;
 $httponly = false;
 $domain = "";
 
 foreach ($parts as $part) {
 $val = explode("=", $part);
 $name = $val[0];
 $value = $val[1];

 if ($name == "path") $path = $value;
 else if ($name == "expire") $expire = $value;
 else if ($name == "domain") $domain = $value;
 else if ($name == "secure") $secure = true;
 else if ($name == "httponly") $httponly = true;
 else $cookies[$name] = $value;
 }

 foreach ($cookies as $name=>$value) {
 $this->receivedCookies[$name] = new FetchCookie($name, $value, $expire, $path, $domain, $secure, $httponly);
 }
 }
}
























class FetchStream extends fetchurl {

 function FetchStream($type = "") {
 $this->fetchurl($type);
 }

 function doRequest() {

 $stream_opts = $this->makeStreamOpts();

 $ctx = stream_context_create($stream_opts);
 if ( ! $ctx ) {
 $this->populateErrorVar("failed creating a context");
 return "";
 }

 
 
 $callback = array(__CLASS__, "streamNotificationCallback");
 stream_context_set_params($ctx, array("notification" => $callback));

 $fp = fopen($this->getUrl(), "r", false, $ctx);
 if ( ! $fp ) {
 
 
 $this->populateErrorVar("failed opening stream");
 return "";
 }

 if ( ! is_null($this->getTimeout()) ) {
 if ( ! stream_set_timeout($fp, $this->getTimeout()) ) {
 $this->populateErrorVar("failed setting stream timeout");
 }
 }

 $contents = stream_get_contents($fp);
 $meta = stream_get_meta_data($fp);
 fclose($fp);

 if ($meta["timed_out"]) {
 $this->error .= "stream timed out";
 }

 $this->populateHeaderVars($meta["wrapper_data"]);

 return $contents;
 }

 



 function getTimeout() {
 global $FETCH_STREAM_MAXTIME;
 global $FETCH_CURL_MAXTIME;
 if (isset($FETCH_STREAM_MAXTIME)) {
 return $FETCH_STREAM_MAXTIME;
 }
 return $FETCH_CURL_MAXTIME;
 }

 



 function getConnectTimeout() {
 global $FETCH_STREAM_CONNECTION_TIMEOUT;
 global $FETCH_CURL_CONNECTION_TIMEOUT;
 if (isset($FETCH_STREAM_CONNECTION_TIMEOUT)) {
 return $FETCH_STREAM_CONNECTION_TIMEOUT;
 }
 return $FETCH_CURL_CONNECTION_TIMEOUT;
 }

 function makeStreamOpts() {

 $post_data = $this->makePostData();

 $stream_opts = array(
 'http' => array(
 'method' => $this->getSubmitType(),
 'header' => $this->makeHeaderString($post_data),
 'content' => $post_data,
 
 
 
 
 
 'ignore_errors' => true,
 ),
 );

 if ( ! is_null($this->getConnectTimeout()) ) {
 $stream_opts['http']['timeout'] = $this->getConnectTimeout();
 }
 return $stream_opts;
 }

 function makePostData() {
 $post_data = "";
 if ( $this->getSubmitType() == "POST"
 || $this->getSubmitType() == "PUT")
 {
 if ($this->PostData !== "") {
 $post_data .= $this->PostData;
 }
 foreach ($this->getPostVars() as $name => $value) {
 if (is_array($value)) {
 foreach ($value as $v) {
 if ($post_data !== "") {
 $post_data .= "&";
 }
 $post_data .= "$name=$v";
 }
 } else {
 if ($post_data !== "") {
 $post_data .= "&";
 }
 $post_data .= "$name=$value";
 }
 }
 }
 return $post_data;
 }

 function makeHeaderString($post_data) {
 $header = "";
 foreach ($this->getHeaders() as $name => $value) {
 if (strtolower($name) != "content-length") {
 $header .= "$name: $value\r\n";
 }
 }
 
 $header .= "Content-Length: ".strlen($post_data)."\r\n";
 return $header;
 }

 


 function populateErrorVar($message) {
 if ($this->error) {
 $this->error .= "; ";
 }
 $this->error .= $message;
 }

 





 function populateHeaderVars($header_array) {
 $this->receiveHeaders = array();
 $this->receiveHeader = "";
 foreach ($header_array as $line) {
 $line = trim($line);
 if ( ! strlen($line) ) {
 continue;
 }
 if (preg_match('/^([^:\s]+):\s*(.*)[\r\n]*$/', $line, $matches)) {
 
 $this->receiveHeaders[$matches[1]][] = $matches[2];
 } else if (preg_match('~^HTTP/\d+.\d+\s+100\s+~i', $line)) {
 
 continue;
 } else {
 
 $this->receiveHeaders[] = $line;
 }
 
 $this->receiveHeader .= "$line\r\n";
 }
 }

 function streamNotificationCallback(
 $notification_code,
 $severity,
 $message,
 $message_code,
 $bytes_transferred,
 $bytes_max)
 {
 
 
 
 if ( STREAM_NOTIFY_FAILURE == $notification_code
 && 404 == $message_code )
 {
 
 
 
 
 
 
 
 
 
 $this->receiveHeader = trim($message)."\r\n";
 $this->receiveHeaders = array(trim($message));
 }
 }
}

class fetchCurl extends fetchurl { 

 var $curl = "";
 var $SSLUser = "";
 var $SSLPw = "";
 
 
 function fetchCurl($type = "") {
 global $CURL_PATH;
 $this->fetchurl($type);
 $this->curl = $CURL_PATH ? $CURL_PATH : "curl";
 }

 
 function setCurl($value) {
 $this->curl = $value;
 }

 function setSSLUser($value) {
 $this->SSLUser = $value;
 }

 function setSSLPassword($value) {
 $this->SSLPw = $value;
 }

 function getCurl() {
 return $this->curl;
 }

 function getSSLUser() {
 return $this->SSLUser;
 }

 function getSSLPassword() {
 return $this->SSLPw;
 }

 function doRequest() {
 if (!function_exists("curl_exec")) {
 return $this->doRequestOnShell();
 }

 
 $connectionTimeout = $GLOBALS['FETCH_CURL_CONNECTION_TIMEOUT'];
 $maxTime = $GLOBALS['FETCH_CURL_MAXTIME'];
 $curlParameters = $GLOBALS['FETCH_CURL_PARAMETERS'];
 $postVars = $this->getPostVars();
 
 
 $postData = $this->getPostData();

 $curl = curl_init();

 
 curl_setopt($curl, CURLOPT_URL, $this->getUrl());

 
 $headerStringArray = array();
 foreach ($this->getHeaders() as $headerName => $headerValue) {
 $headerStringArray[] = $headerName . ": " . $headerValue;
 }

 
 if (!empty($this->SSLUser)) {
 curl_setopt($curl, CURLOPT_USERPWD, $this->SSLUser . (empty($this->SSLPw) ? "" : ":" . $this->SSLPw));
 }

 
 curl_setopt($curl, CURLOPT_HTTPHEADER, $headerStringArray);
 curl_setopt($curl, CURLOPT_CONNECTTIMEOUT, $connectionTimeout);
 curl_setopt($curl, CURLOPT_TIMEOUT, $maxTime);
 curl_setopt($curl, CURLOPT_RETURNTRANSFER, true);
 curl_setopt($curl, CURLOPT_VERBOSE, true);
 curl_setopt($curl, CURLOPT_HEADER, true);

 
 if (count($postVars) > 0) {
 
 curl_setopt($curl, CURLOPT_POST, count($postVars));
 curl_setopt($curl, CURLOPT_POSTFIELDS, http_build_query($postVars));
 } else if (!empty($postData)) {
 
 curl_setopt($curl, CURLOPT_CUSTOMREQUEST, "POST"); 
 curl_setopt($curl, CURLOPT_POSTFIELDS, $postData); 
 }

 
 $response = curl_exec($curl);

 
 $headerSize = curl_getinfo($curl, CURLINFO_HEADER_SIZE);
 $responseHeaders = substr($response, 0, $headerSize);
 $responseBody = substr($response, $headerSize);

 $this->receiveHeaders = explode("\n", $responseHeaders);
 $this->receiveHeader = $responseHeaders;

 
 curl_close($curl);

 return $responseBody;
 }

 
 function doRequestOnShell() {
 
 global $FETCH_CURL_CONNECTION_TIMEOUT, $FETCH_CURL_MAXTIME, $FETCH_CURL_PARAMETERS;

 
 $curl = $this->curl . $this->buildHeaders() . $this->buildSSL();
 
 if( $FETCH_CURL_CONNECTION_TIMEOUT ) $curl .= " --connect-timeout $FETCH_CURL_CONNECTION_TIMEOUT ";
 if( $FETCH_CURL_MAXTIME ) $curl .= " --max-time $FETCH_CURL_MAXTIME ";
 if( $FETCH_CURL_PARAMETERS ) $curl .= " $FETCH_CURL_PARAMETERS ";
 
 $postfilename = NULL;
 if ($this->getSubmitType() == "POST") {
 $postvars .= $this->buildPostVars(FALSE);
 
 if( strlen( $postvars ) > 50 ) {
 $postfilename = "/Node/tmp/curl_data_".getmypid().".txt";
 $curl .= " -d @$postfilename"; 
 $outfile = fopen( $postfilename, 'w' );
 
 fwrite( $outfile, $postvars );
 fclose( $outfile );
 } else {
 $curl .= " -d ".escapeshellarg( $postvars );
 }
 }

 $curl .= " -s -i ".escapeshellarg($this->getUrl());
 $fp = popen($curl, 'r');

 if (!$fp) { return ""; }
 $headers = Array();
 $continue = 0;
 while (!feof($fp)) {
 $line = fgets($fp,1024);
 if ($line == "\r\n" || $line == "\n") {
 if ( $continue > 0 ) {
 $continue--;
 continue;
 } else {
 break;
 }
 }
 if (eregi("^HTTP/1.[01] 100 Continue",$line,$regs)) {
 $continue++;
 } else if (eregi("^([^:]+): ?(.*)([\r\n]*)$",$line,$regs)) {
 $headers[$regs[1]][] = $regs[2];
 $this->receiveHeader .= $line;
 } else {
 $headers[] = $line;
 $this->receiveHeader .= $line;
 }
 }
 $content = "";
 while (!feof($fp)) {
 $content .= fread($fp,65535);
 }
 fclose($fp);
 if( $postfilename !== NULL ) {
 
 unlink( $postfilename );
 }

 $this->receiveHeaders = $headers;
 return $content;
 }

 
 function buildHeaders() {
 
 $rs = "";

 $headers = $this->getHeaders();

 reset($headers);
 while (list($key,$val) = each($headers)) {
 $rs .= " -H ".escapeshellarg($key.": ".$val);
 }
 
 
 $rs = str_replace("\n", "", $rs);
 return $rs;
 }

 function buildPostVars($witharg = TRUE) {
 
 $rs = "";

 $postvars = $this->getPostVars();

 if ($this->PostData != "") {
 $rs .= ($witharg ? " -d ".escapeshellarg($this->PostData) : $this->PostData);
 }

 reset($postvars);
 while (list($key,$val) = each($postvars)) {
 $rs .= ($witharg ? " -d ".escapeshellarg($key."=".$val) : ($rs != '' ? '&' : '') . $key.'='.$val);
 }
 return $rs;
 }
 
 function buildSSL() {

 $rs = "";

 if ($this->SSLUser) {
 $login = $this->SSLUser;
 if ($this->SSLPw) ":".$login .= $this->SSLPw;
 $rs = " -u ".escapeshellarg($login);
 }
 
 return $rs;
 }
}

?>
