/**
 * QuickJump manager
 */
var GTXQuickJump = {
	/**
	 * initializes the quickjumper
	 * @param string STAG
	 * @param bool fade quickjumper on submit event
	 * @return void
	 */
	init: function(sTag, fadeOnSubmit) {
		// turn input field into autocomplete
		// Todo: find out why this is sometimes invalid
		if (jQuery.isFunction(jQuery("#pagejump").autocomplete)) {
			jQuery("#pagejump").autocomplete(sTag, {
				delay: 250,
				width: 200,
				max: 15,
				minChars: 3
			}).result(this.formatResult);
		}

		if (fadeOnSubmit) {
			jQuery("#quickjump form").submit(function () {
				jQuery('#quickjump').fadeOut("fast");
				jQuery("#treeTable").fadeTo("normal", 1);
			});
		}

		jQuery("#pagejumpId").attr("value", "");
	},
	
	/**
	 * show the qickjumper
	 * @return void
	 */
	show: function() {
    	jQuery("#treeTable").fadeTo("normal", .4);
    	jQuery('#quickjump').fadeIn("fast");
		jQuery("#pagejump").focus();		
	},
	
	/**
	 * hide the quickjumper
	 * @return void
	 */
	hide: function() {
		jQuery('#quickjump').fadeOut("fast");
		jQuery("#treeTable").fadeTo("normal", 1);
	},
	
	/**
	 * this is triggered when a result is selected from the list
	 * @param object event object
	 * @param array data that has been selected
	 * @param string formatted version of data
	 */
	formatResult: function(event, data, formatted) {
		pageName = data[0].replace(/.*<div class="ac_page"[^>]+>(.+)<\/div>$/, "$1");
		pageId = data[0].replace(/.*<div class="ac_page" page_id="(\d+)" node_id="\d+">.+<\/div>$/, "$1");
		nodeId = data[0].replace(/.*<div class="ac_page" page_id="\d+" node_id="(\d+)">.+<\/div>$/, "$1");
		jQuery("#pagejump").attr("value", pageName);
		jQuery("#pagejumpId").attr("value", pageId);
		jQuery("#pagejumpnodeId").attr("value", nodeId);
		jQuery("#quickjump form").submit();
	}
};