<?php

class FormattedDataSource extends ItemListDataSource {

 var $m_links = Array();
 var $m_jslinks = Array();
 var $mailto_links = Array();
 var $m_formatter = Array();
 var $m_assFormatter = Array();
 var $m_ass = "";
 var $m_colAttribs = Array();
 var $m_wrappable = Array();
 var $m_plainCols = Array();
 var $m_plainHeaders = Array();
 var $m_plainSort = false;

 


 var $m_colFilters = Array();

 function getResultSet( $fromIdx, $toIdx, &$count, $search = "", $fetchAll=FALSE ) {
 $rs = $this->getPlainResultSet($fromIdx,$toIdx, $count, $search, $fetchAll || $this->m_plainSort);
 $rs = $this->handlePlainColumns( $rs );
 return $this->formatResultSet($rs);
 }
 
 
 function getPlainResultSet( $fromIdx, $toIdx, &$count, $search="", $fetchAll=FALSE) {}

 
 
 function _addColumn( $col, $header ) {
 $this->m_plainCols[$col] = array( "header"=>$header, "native"=>true );
 $this->m_plainHeaders[$col] = $header;
 }
 
 function addSourceColumn( $col, $header, &$source, $visible=true ) {
 $this->m_plainCols[$col] = array( "header"=>$header, "source"=>&$source, "native"=>false );
 if ( $visible )
 $this->m_plainHeaders[$col] = $header;
 }
 
 function addPlainColumn( $col, $header ) {
 $this->_addColumn($col, $header);
 }
 
 function setSorter( $col, &$sorter ) {
 $this->m_plainCols[$col]["sorter"] = &$sorter;
 }
 

 function handlePlainColumns( $rs ) {
 foreach ( $rs as $key=>$val )
 {
 foreach ( $this->m_plainCols as $pKey=>$pVal )
 {
 if ( !$pVal["native"] ) {
 $rs[$key][$pKey] = $pVal["source"]->getContent( $val );
 }
 }
 }
 return $rs;
 } 
 
 function getSortWays( $column ) {
 
 }
 
 function setSort($column, $way = false) {
 
 }

 function getColumns() {
 return array_keys( $this->m_plainHeaders );
 } 
 
 function getColumnHeader( $column ) {
 return $this->m_plainHeaders[$column];
 }
 
 
 
 
 function formatResultSet($rs) {
 
 $rs = $this->_callFormatters($rs); 
 $rs = $this->_formatMailtoLinks($rs);
 $rs = $this->_formatLinks($rs);
 $rs = $this->_formatJSLinks($rs);
 return $rs;
 }
 
 function _formatLinks($rs) {
 global $STAG;
 foreach($this->m_links as $link) {
 reset($rs);
 while (list($key,$val) = each($rs)) {
 if ($link["paramname"]) {
 if( is_array( $link["paramname"] ) ) {
 $param = "";
 for( $i = 0 ; $i < count( $link["paramname"] ) ; $i++) {
 $param .= "&".$link["paramname"][$i]."=".urlencode($rs[$key][$link["paramcolumn"][$i]]);
 }
 } else {
 $param = "&".$link["paramname"]."=".urlencode($rs[$key][$link["paramcolumn"]]);
 }
 } else $param = "";
 
 $lName = $rs[$key][$link["sourcecolumn"]];
 if ( !$lName ) $lName = "-";
 if ( !$link["checkcolumn"] || ($link["checkcolumn"] && $rs[$key][$link["checkcolumn"]]) ) {
 $rs[$key][$link["newcolumn"]] = "<a href=\"javascript:".
 ProgressStatusInfo::buildProgressLink( $STAG."&".$link["url"].$param, $link["target"] )."\" target=\"".$link["target"]."\">".$lName."</a>";
 } else {
 $rs[$key][$link["newcolumn"]] = $lName;
 }
 }
 }
 return $rs;
 }
 function _formatJSLinks($rs) {
 global $STAG;
 foreach($this->m_jslinks as $link) {
 reset($rs);
 while (list($key,$val) = each($rs)) {
 if ($link["paramcolumn"]) {
 $param = ", '".addslashes($rs[$key][$link["paramcolumn"]]) . "');";
 } else $param = "";
 
 $lName = $rs[$key][$link["sourcecolumn"]];
 if ( !$lName ) $lName = "-";
 $rs[$key][$link["newcolumn"]] = "<a href=\"javascript:".$link["js"]."$param\" target=\"".$link["target"]."\">".$lName."</a>";
 }
 }
 return $rs;
 }
 
 function _callFormatters($rs) {
 global $STAG;
 foreach ( $this->m_formatter as $f ) {
 $formatter = &$f["formatter"];
 reset($rs);
 while ( list($key,$val) = each($rs) ) {
 $rs[$key][$f["newcolumn"]] = $formatter->format( $rs[$key], $f["param"] );
 }
 }
 return $rs;
 }
 
 function _formatMailtoLinks($rs) {
 foreach ($this->mailto_links as $mlink) {
 while (list($key, $val) = each($rs)) {
 $rs[$key][$mlink["newcolumn"]] = "<a href=\"mailto:".$rs[$key][$mlink["sourcecolumn"]]."\">".$rs[$key][$mlink["sourcecolumn"]]."</a>\n";
 }
 reset($rs);
 }
 return $rs;
 }

 function makeJSLink($newcol, $sourcecol, $js, $target = "", $paramcolumn = "") {
 $this->m_jslinks[$newcol] = Array("newcolumn"=>$newcol, "sourcecolumn"=>$sourcecol, "js"=>$js, "target"=>$target, "paramcolumn"=>$paramcolumn);
 }
 
 function makeLink($newcol, $sourcecol, $url, $target = "", $paramname = "", $paramcolumn = "", $checkColumn = "") {
 $this->m_links[$newcol] = Array("newcolumn"=>$newcol, "sourcecolumn"=>$sourcecol, "url"=>$url, "target"=>$target, "paramname"=>$paramname, "paramcolumn"=>$paramcolumn, "checkcolumn"=>$checkColumn);
 }
 
 function makeMailtoLink($newcol, $sourcecol) {
 $this->mailto_links[$newcol] = Array("newcolumn"=>$newcol, "sourcecolumn"=>$sourcecol);
 }
 
 function addFormatter( $newcol, &$formatter, $param="" )
 {
 $this->m_formatter[] = array( "newcolumn"=>$newcol, "formatter"=>&$formatter, "param"=>$param );
 } 
 
 function getRowHelp( $rowKey, $rowData ) {
 $tmp = $this->_evalAss($rowData, $this->m_ass);
 if ( $tmp )
 $ret = "$tmp<br />";
 else
 $ret = "";
 foreach ( $this->m_assFormatter as $key=>$val )
 {
 $tmp = $this->m_assFormatter[$key]["formatter"]->format( $rowData,
 $this->m_assFormatter[$key]["param"] );
 if ( $tmp )
 $ret .= "$tmp<br />";
 }
 return $ret;
 }
 
 function addAssFormatter( &$formatter, $param = "" ) 
 {
 $rs = array(
 "formatter" => &$formatter,
 "param" => $param
 );
 $this->m_assFormatter[] = $rs;
 }
 
 function setAss($ass) {
 $this->m_ass = $ass;
 }
 
 function _evalAss($_rs,$_data) {
 foreach($_rs as $_key=>$_value) {
 $$_key = $_value;
 }
 $tmp = "";
 eval("\$tmp = \"$_data\";");
 return $tmp;
 }
 
 function addColumnAttribs( $column, $attr )
 {
 if ( !isset($this->m_colAttribs[$column]) )
 $this->m_colAttribs[$column] = $attr;
 else
 $this->m_colAttribs[$column] .= " ".$attr; 
 }
 
 function getColumnAttribs( $column )
 {
 return $this->m_colAttribs[$column];
 } 

 function isWrappable( $column )
 {
 if ( !isset( $this->m_wrappable[$column] ) )
 return FALSE;
 return $this->m_wrappable[$column];
 }
 
 function setWrappable( $column, $isWrappable=TRUE )
 {
 $this->m_wrappable[$column] = $isWrappable;
 }

 




 function setColumnFilter ($column, $filter) {
 $this->m_colFilters[$column] = $filter;
 }

 




 function getColumnFilter($column) {
 return $this->m_colFilters[$column];
 }

 




 function hasColumnFilter($column) {
 return $this->m_colFilters[$column] ? true : false;
 }
}

?>
