<?php













class ProcessLogger {

 var $keyname;

 var $logfile;

 var $flog;

 var $fullkey;

 var $files;

 var $writeToStdOut;

 var $syncPid;

 


 public static $lockfile = false;

 



 public static $lockCount = 0;

 





 function ProcessLogger($keyname) {
 global $FILEPATH, $MODULE, $FEATURE;

 $this->keyname = $keyname;
 $this->logfile = "$FILEPATH/$MODULE/log/$keyname"."_log.html";
 checkpath("$FILEPATH/$MODULE/log");

 $this->fullkey = "sync_$MODULE:$keyname";

 $this->files = array();
 
 $this->syncPid = $FEATURE["pidsync"];

 $this->writeToStdOut = false;
 }

 





 function acquireGlobalLock() {
 if (ProcessLogger::$lockCount == 0) {
 ProcessLogger::$lockfile = fopen("/Node/tmp/processlogger.lock", "a+");
 if (!ProcessLogger::$lockfile) {
 exit("Couldn't create ProcessLogger global lock file\n");
 }
 if (!flock(ProcessLogger::$lockfile, LOCK_EX)) {
 exit("Couldn't acquire ProcessLogger global lock\n");
 }
 }
 ProcessLogger::$lockCount++;
 }
 
 



 function releaseGlobalLock() {
 if (ProcessLogger::$lockCount > 0) {
 ProcessLogger::$lockCount--;
 if (ProcessLogger::$lockCount == 0) {
 if (!flock(ProcessLogger::$lockfile, LOCK_UN)) {
 exit("Couldn't free ProcessLogger global lock\n");
 }
 fclose(ProcessLogger::$lockfile);
 ProcessLogger::$lockfile = null;
 }
 }
 }

 


 function getKeyname() {
 return $this->keyname;
 }

 


 function getLogFilename() {
 return $this->logfile;
 }

 




 function setSyncByPid($value) {
 $this->syncPid = $value;
 }

 




 function doSyncByPid($value) {
 return $this->syncPid;
 }

 




 function writeToStdOut($value) {
 $this->writeToStdOut = $value;
 
 }

 




 function writesToStdOut() {
 return $this->writeToStdOut;
 }

 









 function addLogFile($keyname, $prefix, $extention = "log", $subdir = "", $append = false) {
 global $FILEPATH, $MODULE;
 $log = new ProcessLoggerFile($this, $keyname);
 $log->initNew($prefix, $extention, $subdir, $append);
 return $log;
 }

 





 function getLogFile($keyname) {
 $log = new ProcessLoggerFile($this, $keyname);
 return $log;
 }

 





 function addText($text, $newline = false) {
 $this->flog->_addLogText($text,$newline);
 $this->flog->_flushLog();
 }

 








 function start($oldintvalue = false) {
 if ($this->syncPid) {
 $val = getmypid();
 } else {
 $val = time();
 }
 $key = "\"".sqlslashes($this->fullkey)."\"";

 $this->flog = new ProcessLoggerFileHandler($this->logfile, $this->writeToStdOut);

 ProcessLogger::acquireGlobalLock();
 
 $sql = "DELETE FROM nodesetup WHERE name = $key";
 query($sql);

 $sql = "INSERT INTO nodesetup (name, intvalue) VALUES ($key, ".sqlf_tl_num($val).")";
 query($sql);
 ProcessLogger::releaseGlobalLock();

 $this->addText("",true);
 if ($oldintvalue) {
 $this->addText($this->_date().": found stale pid $oldintvalue", true);
 }
 $this->addText($this->_date().": starting.. ($val)", false);
 return true;
 }

 





 function stop($errormsg = false) {
 ProcessLogger::acquireGlobalLock();
 $sql = "UPDATE nodesetup SET intvalue = 0 WHERE name = \"".sqlslashes($this->fullkey)."\"";
 query($sql);
 ProcessLogger::releaseGlobalLock();
 
 $this->addText(" -- ".$this->_date().": ".(($errormsg)?"<font color=red>$errormsg</font>":"done").".", false);
 
 $this->flog->_close();
 }

 




 function skip() {
 
 $this->flog = new ProcessLoggerFileHandler($this->logfile, $this->writeToStdOut);

 $this->addText($this->_date().": skipping.",true);

 $this->flog->_close();
 }

 







 function isRunning($timeout) {
 ProcessLogger::acquireGlobalLock();
 $result = $this->isRunningGetProcessId($timeout) === true;
 ProcessLogger::releaseGlobalLock();
 return $result;
 }

 



 function isRunningGetProcessId($timeout) {
 $sql = "SELECT intvalue FROM nodesetup WHERE name = \"".sqlslashes($this->fullkey)."\"";
 $rs = query($sql);
 
 if (!$rs["num"]) return false;

 $intValue = $rs["arr"][0]["intvalue"];
 if ($intValue == 0) return 0;
 if ($this->syncPid) {
 if ($this->isSystemWindows()) {
 
 $taskListCommand = 'tasklist /v /nh /fo csv /fi "PID eq ' . $intValue . '"';
 $lastLineFromOutput = exec($taskListCommand);

 
 
 
 return strstr($lastLineFromOutput, '","') !== false;
 } else {
 
 if (!posix_getpgid($intValue) && !@stat("/proc/".$intValue)) {
 return $intValue;
 }
 }
 } else {
 if ($intValue < time() - $timeout) return $intValue;
 }

 return true;
 }

 




 function isSystemWindows()
 {
 return strtoupper(substr(PHP_OS, 0, 3)) === 'WIN';
 }

 





 function checkRunningAndStart($timeout) {
 ProcessLogger::acquireGlobalLock();
 $pid = $this->isRunningGetProcessId($timeout);
 if ($pid === true) {
 ProcessLogger::releaseGlobalLock();
 return false;
 }
 $result = $this->start($pid);
 ProcessLogger::releaseGlobalLock();
 return $result;
 }

 









 function cycleLogs($cycleTime = 2, $compressFiles = true, $createSubdir = false, $packArchives = true, $packBroken = true) {
 global $TIME, $FILEPATH, $MODULE;
 
 switch ($cycleTime) {
 case 1:
 $lastdate = date("Y-m-d",mktime(0,0,0,date("m",$TIME),date("d",$TIME),date("Y",$TIME)));
 $spacer = "_";
 break;
 case 3:
 $lastdate = date("Y",mktime(0,0,0,1,1,date("Y",$TIME)));
 $spacer = "-";
 break;
 case 2:
 default:
 $lastdate = date("Y-m",mktime(0,0,0,date("m",$TIME),0,date("Y",$TIME)));
 $spacer = "-";
 }
 
 $dir = "$FILEPATH/$MODULE/log/";
 
 reset($this->files);
 while (list($key,$val) = each($this->files)) {
 $pl = $this->getLogFile($key);

 $target = $dir;
 if ($sub = $pl->getSubdir()) $target .= $sub."/";
 $source = $target;
 $target .= $pl->getPrefix()."_".$lastdate.".".$pl->getExtention().".tar";
 
 $source .= $pl->getPrefix()."_".$lastdate.$spacer."*.".$pl->getExtention();

 if (!file_exists($target)) {
 $sources = "$source.gz";

 if ($compressFiles) {
 system("/bin/gzip $source");
 } else {
 $sources .= " $source";
 }
 
 if ($packArchives) {
 $sources .= " $source.tar";
 }

 if ($packBroken) {
 
 }
 system("/bin/tar -cf $target $sources");
 system("/bin/rm -f $sources");
 }
 
 }
 }

 




 function logDate() {
 return $this->_date();
 }
 
 


 function _date() {
 return date("d.m.Y H:i:s");
 }

}

class ProcessLoggerFile {

 var $logger;
 var $keyname;
 
 var $stats;
 var $header;
 var $footer;

 function ProcessLoggerFile(&$logger, $keyname) {
 $this->logger =& $logger;
 $this->keyname = $keyname;
 }

 function initNew($prefix, $extention = "log", $subdir = "", $append = false) {
 global $TIME, $FILEPATH, $MODULE;
 $filename = "$FILEPATH/$MODULE/log/";
 if ($subdir) $filename .= $subdir."/";
 $filename .= $prefix."_".date("Y-m-d_H-i-s",$TIME).".".$extention;
 $this->logger->files[$this->keyname]["fp"] = new ProcessLoggerFileHandler($filename, $this->logger->writesToStdOut());
 $this->logger->files[$this->keyname]["prefix"] = $prefix;
 $this->logger->files[$this->keyname]["extention"] = $extention;
 $this->logger->files[$this->keyname]["subdir"] = $subdir;
 $this->logger->files[$this->keyname]["filename"] = $filename;
 }

 function initFile($filename) {
 $this->logger->files[$this->keyname]["filename"] = $filename;
 
 $this->logger->files[$this->keyname]["fp"] = new ProcessLoggerFileHandler($filename, $this->logger->writesToStdOut());
 }

 function getFilename() {
 return $this->logger->files[$this->keyname]["filename"];
 }

 function getPrefix() {
 return $this->logger->files[$this->keyname]["prefix"];
 }

 function getExtention() {
 return $this->logger->files[$this->keyname]["extention"];
 }

 function getSubdir() {
 return $this->logger->files[$this->keyname]["subdir"];
 }

 







 function addText($text, $newline = true, $addDate = false) {
 if ($addDate) $text = $this->logger->logDate().": ".$text;
 $fp =& $this->logger->files[$this->keyname]["fp"];
 $fp->_addLogText($text, $newline);
 $fp->_flushLog();
 }

 


 function setStatistic($text) {
 $this->stats = $text;
 }

 


 function setSummary($text) {
 $this->footer = $text;
 }

 


 function setHeader($text) {
 $this->header = $text;
 }

 





 function finalize() {
 if (!($this->stats || $this->header || $this->footer)) return;
 
 $this->logger->files[$this->keyname]["fp"]->_finalizeLog($this->header, $this->stats, $this->footer);

 $this->stats = "";
 $this->header = "";
 $this->footer = "";
 }

 





 function compressLog($cleanUp = true) {
 global $FILEPATH, $MODULE;
 
 $this->logger->files[$this->keyname]["fp"]->_close();
 
 system("/bin/gzip ".$this->logger->files[$this->keyname]["filename"]);

 if ($cleanUp) {
 
 
 $source = "$FILEPATH/$MODULE/log/";
 if ($sub = $this->getSubdir()) $source .= $sub."/";
 $source .= $this->getPrefix()."_*.".$this->getExtention();
 $target = "$FILEPATH/$MODULE/log/broken/".$this->logger->getKeyname();
 checkpath($target,0700);
 
 system("mv $source $target >/dev/null 2>&1");
 $source = $target."/".$this->getPrefix()."_*.".$this->getExtention();
 system("/bin/gzip $source >/dev/null 2>&1");
 }
 }

 



 function getFormattedLog() {
 
 }

}









class ProcessLoggerFileHandler {
 
 var $filename;
 var $tostdout;

 function ProcessLoggerFileHandler($filename, $tostdout = false) {
 $this->filename = $filename;
 checkpath(dirname($filename),0700);
 $this->tostdout = $tostdout;
 }
 
 function _close() {
 }
 
 




 function _finalizeLog($header,$stats,$footer) {
 
 
 $this->_close();
 
 $text = $this->_fetchLogText();

 
 $text = $header."\n".$stats."\n".$text."\n".$footer;

 $this->_writeLogText($text);
 }

 






 function _addLogText($text, $newline = false) {
 if ($newline) $text .= "\n";
 file_put_contents($this->filename, $text, FILE_APPEND);
 if ($this->tostdout) echo $text;
 }

 




 function _fetchLogText() {
 return implode("\n",file($this->filename));
 }

 


 function _flushLog() {
 }

 



 function _writeLogText($text) {
 $fp = fopen($this->filename, "w+");
 fwrite($fp, $text);
 if ($this->tostdout) echo $text;
 fclose($fp);
 }
}

?>
