<?php

class OptionsComponent extends FormComponent
{
 function OptionsComponent( $label="", $options=array(), $preSelected=false, 
 $optional=false ) {
 parent::FormComponent( $label, true, $optional );
 $this->d_values["s"] = array();
 $this->setOptions( $options );
 if ( $preSelected !== NULL && $preSelected !== false)
 $this->setSelection( $preSelected );
 }

 function size()
 {
 return count( $this->d_values["options"] ); 
 }
 
 function swapOptions( $key1, $key2 )
 {
 $this->d_values["options"] = NodeArrayObject::swap( $this->d_values["options"], $key1, $key2 ); 
 }
 
 function replaceOption( $key, $newValue, $newKey=FALSE )
 {
 if ( is_false($newKey) )
 $this->d_values["options"][$key] = $newValue;
 else
 {
 $this->d_values["options"] = NodeArrayObject::replace( $this->d_values["options"], 
 $key, $newValue, $newKey );
 $sel = $this->getSelection();
 foreach ( $sel as $sval )
 {
 $newsel = array();
 if ( $sval == $key )
 $newsel[] = $newKey;
 else
 $newsel[] = $sval;
 }
 $this->setSelection( $newsel );
 } 
 }
 
 function moveOptionUp( $key )
 {
 $arr = NodeArrayObject::moveUp( $this->d_values["options"], $key );
 if ( is_false( $arr ) ) return FALSE;
 $this->d_values["options"] = $arr;
 return TRUE; 
 }
 
 function moveOptionDown( $key )
 {
 $arr = NodeArrayObject::moveDown( $this->d_values["options"], $key );
 if ( is_false( $arr ) ) return FALSE;
 $this->d_values["options"] = $arr;
 return TRUE; 
 }
 
 function removeOption( $key )
 {
 unset( $this->d_values["options"][$key] );
 unset( $this->d_values["s"] );
 }
 
 function setOption( $key, $value )
 {
 $this->d_values["options"][$key] = $value;
 }
 
 function setOptions( $options )
 {
 $this->d_values["options"] = $options;
 }
 
 function getOptions()
 {
 return $this->d_values["options"];
 }
 

 function clearSelection()
 {
 $this->d_values["s"] = array();
 }
 
 function setSelection( $selection )
 {
 if (is_Array($selection)) {
 $this->d_values["s"] = $selection;
 } else {
 $this->d_values["s"][] = $selection;
 }
 }
 
 function getSelection()
 {
 return $this->d_values["s"];
 }

 function getSingleSelection()
 {
 $s = $this->getSelection();
 if ( is_array( $s ) )
 return $s[0];
 return NULL;
 } 
 
 function isSelected()
 {
 return $this->d_values["s"] !== NULL && count($this->d_values["s"]) > 0;
 }
 
 function setOnChangeAction( $action )
 {
 $this->d_values["onchange"] = $action;
 }

 function setOnClickAction( $action )
 {
 $this->d_values["onclick"] = $action;
 }
 
 






 function getFields() {
 return array_merge( parent::getFields(), array( "s"=>"The Selector" ) );
 }

 function getFocusableElementName()
 {
 if ( $this->isEditable() )
 return "s";
 return NULL;
 }
 

 function toString()
 {
 $opts = $this->getOptions();
 $sel = $this->getSelection();
 
 if ( !is_array( $sel ) ) 
 {
 if ( !isset( $opts[$sel] ) )
 return i18n( "No option selected." );
 else
 return $opts[$sel];
 }

 $first = FALSE;
 $ret = "";
 foreach ( $sel as $s )
 {
 if ( $first )
 $first = FALSE;
 else
 $ret .= ", ";
 $ret .= $opts[$sel];
 }
 return $ret;
 }
 
 function &getResultObject() {
 node_class("StringObject");
 return new StringObject($this->getSelection());
 }

 function onLoadFinished()
 {
 parent::onLoadFinished();
 if ( !$this->isOptional() )
 {
 $sel = $this->getSelection();
 if ( !$sel )
 $this->addError( new NodeException( i18n( "An element must be selected!" ) ) );
 }
 }
}
 
class SelectComponent extends OptionsComponent
{
 var $autoTitle = false;
 var $noneName = "----";
 
 function setAutoTitle($to) {
 $this->autoTitle = $to;
 }
 
 function enableMultipleSelect( $size )
 {
 $this->d_values["multiple"] = $size;
 $this->d_values["size"] = $size;
 }
 
 function connectToDoubleClickActionJs( $js )
 {
 $this->d_values["ondblclick"] = "ondblclick=\"".$js."\"";
 }
 
 function setSize( $size )
 {
 $this->d_values["size"] = $size;
 }
 
 function getFocusableElementName()
 {
 if ( $this->isEditable() )
 return "s[]";
 return NULL;
 }

 function setAllowEmpty( $allow )
 {
 $this->d_values["noempty"] = !$allow;
 }

 


 function setNoneName( $text )
 {
 $this->noneName = $text;
 }

 







 
 function getHTML( &$form, $fieldPrefix, $doCheck, $checkSeverity, $key ) {
 if ( $this->d_values["onchange"] )
 {
 $onchange = "onchange=\"".
 $form->getJsActionCall( $this->d_values["onchange"] )
 . "\"";
 }
 if ( $this->d_values["onclick"] )
 {
 $onclick = "onclick=\"".
 $form->getJsActionCall( $this->d_values["onclick"] )
 . "\"";
 }
 $strStyle = $this->_translateStyle( $doCheck, $checkSeverity );
 $optional = $this->isOptional()?"true":"false";
 $formName = $form->getFormName();
 $eMsg = i18n( "An element must be selected!" );
 $form->addJsCheck( array( "checkSelection( '$formName', '${fieldPrefix}s[]', '-9999',".
 " '$eMsg', $optional, focusOnError )", "${fieldPrefix}s" ) );
 
 $sel = parent::getSelection();
 $isMultiple = $this->d_values["multiple"] > 0; 
 if ( $isMultiple )
 {
 $size = "size=".$this->d_values["multiple"];
 $multiple = "multiple";
 $html .= "<input type=hidden name=${fieldPrefix}s[]>";
 }

 if ( $this->d_values["size"] )
 $size = "size=".$this->d_values["size"];

 if ( !is_array($sel) )
 $sel = array();
 $nothingSelected = in_array( -9999, $sel );
 $selected = ($nothingSelected?"SELECTED":"");
 
 $ondblclick = $this->d_values["ondblclick"];
 $onkeydown = $this->getOnKeyDown();
 
 $html .= "<select $onchange $onclick $ondblclick name=${fieldPrefix}s[] class=solid style=\"$strStyle\" \n$size $multiple \n$onkeydown ";
 if ( ! $this->isEditable() ) {
 $html .= " disabled ";
 }

 $syntax = $regexErr;
 if ( $help = $this->createHelpJsEvents( $form, $fieldPrefix, $syntax ) ) {
 $html .= $help["html"]." ";
 }


 $html .= ">\n";
 if ( !$this->d_values["noempty"] )
 $html .= "<option $selected value=\"-9999\">" . $this->noneName . "</option>\n";
 $opts = $this->getOptions();
 foreach ( $opts as $key=>$opt )
 {
 if ( $this->d_values["title"][$key] )
 $title = "title=\"".htmlentities_utf8($this->d_values["title"][$key])."\"";
 else
 $title = "";
 
 if ($this->autoTitle && $title === "") {
 $title = "title=\"" . htmlentities_utf8($opt) . "\"";
 }
 $selected = (in_array( $key, $sel ))?"SELECTED":"";
 $html .= "<option $title $selected value=\"$key\">".
 htmlentities_utf8($opt).
 "</option>\n";
 }
 $html .= "</select>\n";
 return $this->mergeResult( array( array( NULL, $this->getErrorDiv( $form, $fieldPrefix.'s' ) ) ),
 $this->mergeResult(parent::getHTML( $form, $fieldPrefix, $doCheck, $checkSeverity, $key ), $html)
 );
 }
 

}

class RadioListComponent extends OptionsComponent {
 var $d_disabled_options = array();

 function setDisabledOptions($disabledOptions) {
 $this->d_disabled_options = $disabledOptions;
 }

 function getHTML( &$form, $fieldPrefix, $doCheck, $checkSeverity, $key ) {
 
 if ( $this->d_values["onchange"] )
 {
 $onchange = "onchange=\"".
 $form->getJsActionCall( $this->d_values["onchange"] )
 . "\"";
 }
 if ( $this->d_values["onclick"] )
 {
 $onclick = "onclick=\"".
 $form->getJsActionCall( $this->d_values["onclick"] )
 . "\"";
 }

 $strStyle = $this->_translateStyle( $doCheck, $checkSeverity );
 $optional = $this->isOptional()?"true":"false";
 $formName = $form->getFormName();
 $eMsg = i18n( "An element must be selected!" );
 $form->addJsCheck( array( "checkRadio( '$formName', '${fieldPrefix}s', ".
 " '$eMsg', $optional, focusOnError )", "${fieldPrefix}s" ) );
 
 $html = "";
 $opts = $this->getOptions();
 $sel = $this->getSelection();
 $name = "${fieldPrefix}s";
 $i=0;
 $entities = false;

 $help = $this->createHelpJsEvents( $form, $fieldPrefix, null );

 foreach ( $opts as $key=>$opt )
 {
 $selected = (in_array($key,$sel) && !in_array($key, $this->d_disabled_options)) ? "CHECKED" : "";
 $disabled = in_array($key, $this->d_disabled_options) ? "disabled" : "";
 $html .= "<input type=radio name=$name id=$name$i $selected $onchange $onclick $disabled style=\"$strStyle\" value=\"$key\" ";
 if ( $help ) {
 $html .= $help["html"]." ";
 }
 $html .= ">";
 $html .= "<label for=$name$i>".($entities?htmlentities_utf8($opt):$opt)."</label><br>\n";
 $i++;
 }
 return $this->mergeResult( array( array( NULL, $this->getErrorDiv( $form, $fieldPrefix.'s' ) ) ),
 $this->mergeResult(parent::getHTML( $form, $fieldPrefix, $doCheck, $checkSeverity, $key ), $html)
 );
 }

 function setFieldValue( $key, $value )
 {
 parent::setFieldValue( $key, ($key=="s")?array($value):$value );
 }

}

class CheckBoxListComponent extends OptionsComponent {

 var $d_checked = array();
 var $d_hidden = false;

 function getFields() {
 return array_merge( parent::getFields(), array( "h"=>"hidden Hack" ) );
 }

 function setFieldValue($key, $value) {
 if ($key == "s") $this->d_checked = $value;
 if ($key == "h") $this->d_hidden = true;
 }

 function onLoadFinished() {
 if ($this->d_hidden) $this->setSelection($this->d_checked);
 $this->d_hidden = false;
 $this->d_checked = array();
 
 parent::onLoadFinished();
 }
 
 function getHTML( &$form, $fieldPrefix, $doCheck, $checkSeverity, $key ) {
 
 if ( $this->d_values["onchange"] )
 {
 
 $onchange = "onclick=\"".
 $form->getJsActionCall( $this->d_values["onchange"] )
 . "\"";
 }
 $strStyle = $this->_translateStyle( $doCheck, $checkSeverity );
 
 $html = "<input type=hidden name=".$fieldPrefix."h value=1>";
 $opts = $this->getOptions();
 $sel = $this->getSelection();
 $name = "${fieldPrefix}s[]";
 $i=0;
 $entities = false;
 foreach ( $opts as $key=>$opt ) {
 $selected = in_array($key,$sel)?"CHECKED":"";
 $html .= "<input type=checkbox name=$name style=\"$strStyle\" value=\"$key\" $selected $onchange";
 if(!$this->isEditable()) {
 $html .= " disabled ";
 
 }

 $syntax = $regexErr;
 if ( $help = $this->createHelpJsEvents( $form, $fieldPrefix, $syntax ) ) {
 $html .= $help["html"]." ";
 }

 $html .= ">";
 $html .= "<label for=$name$i>".($entities?htmlentities_utf8($opt):$opt)."</label><br>\n";
 }
 
 return $this->mergeResult( array( array( NULL, $this->getErrorDiv( $form, $fieldPrefix.'s' ) ) ),
 $this->mergeResult(parent::getHTML( $form, $fieldPrefix, $doCheck, $checkSeverity, $key ), $html)
 );
 }

}

class CheckBoxComponent extends CheckBoxListComponent {

 function CheckBoxComponent($label = NULL, $preSelected = false, $checkLabel = "", $value = 1, $editable=true, $optional=true) {
 $sel = ($preSelected?array($value):array());
 parent::CheckBoxListComponent($label, array($value=>$checkLabel), $sel, $optional);
 
 $this->setOptional($optional);
 $this->setEditable($editable);
 }

 function isChecked() {
 $s = $this->getSelection();
 return ($s[0])?true:false;
 }
}

?>
