<?php

define("TABMODE_TOP", 0x1);
define("TABMODE_LEFT", 0x2);
define("TABMODE_RIGHT", 0x4);
define("TABMODE_BOTTOM", 0x8);

class TabComponent extends CollectionComponent {

 var $d_tabs;
 var $d_activeTab;
 var $d_mode;
 var $d_icons;
 var $d_fullSizedTabs;

 


 function TabComponent($mode = TABMODE_TOP, $fullSized = true) {
 parent::CollectionComponent();
 $this->d_tabs = array();
 $this->d_activeTab = "";
 $this->d_mode = $mode;
 $this->d_icons = array();
 $this->d_fullSizedTabs = $fullSized;
 }

 function setTab($key, $label, &$component, $icon = "") {
 if ($label == "") return false;
 if (!$this->d_values["activeTab"]) $this->d_values["activeTab"] = $key;
 $this->d_tabs[$key] = $label;
 $this->d_icons[$key] = $icon;
 $this->setComponent($key, $component);
 }

 function& getTab( $key )
 {
 return $this->getComponent( $key );
 }

 function tabExists( $key )
 {
 return $this->componentExists( $key );
 }

 function setTabLabel($key, $label) {
 if ($label == "" || !isset($this->d_tabs[$key])) return false;
 $this->d_tabs[$key] = $label;
 }

 function setTabIcon($key, $icon) {
 if (!isset($this->d_tabs[$key])) return false;
 $this->d_icons[$key] = $icon;
 }

 function getTabs() {
 return $this->d_tabs;
 }

 function getTabLabel($key) {
 if (!isset($this->d_tabs[$key])) return false;
 return $this->d_tabs[$key];
 }

 function getTabIcon($key) {
 if (!isset($this->d_tabs[$key])) return false;
 return $this->d_icons[$key];
 }

 function &removeTab($key) {
 if (!isset($this->d_tabs[$key])) return false;
 unset($this->d_tabs[$key]);
 return $this->removeComponent($key);
 }

 function clearTabs() {
 foreach ($this->d_tabs as $key=>$val) {
 $this->removeTab($key);
 }
 }

 function setActiveTab($key) {
 $this->d_values["activeTab"] = $key;
 }

 function getActiveTabName() {
 return $this->d_values["activeTab"];
 }

 



 function setShowOnlyContent($onlycontent) {
 $this->d_values['onlycontent'] = $onlycontent;
 }

 function getShowOnlyContent() {
 return $this->d_values['onlycontent'];
 }

 function getNextTabName( $nextTo = false )
 {
 if ( !$nextTo ) $nextTo = $this->getActiveTabName();
 reset( $this->d_tabs );
 while ( list($key, $val) = each( $this->d_tabs ) )
 {
 if ( $key == $nextTo )
 {
 if ( list($nkey, $nval ) = each( $this->d_tabs ) )
 return $nkey;
 reset( $this->d_tabs );
 return key( $this->d_tabs );
 }
 }
 }

 function getPrevTabName( $prevTo = false )
 {
 if ( !$prevTo ) $prevTo = $this->getActiveTabName();
 $prev = false;
 reset( $this->d_tabs );
 while ( list($key, $val) = each( $this->d_tabs ) )
 {
 if ( $key == $prevTo )
 {
 if ( $prev ) return $prev;
 end( $this->d_tabs );
 return key( $this->d_tabs );
 }
 $prev = $key;
 }
 }

 
 function &getActiveTabComponent() {
 return $this->getComponent( $this->getActiveTabName() );
 }

 function setMode( $mode ) {
 $this->d_mode = $mode;
 }

 function getMode() {
 return $this->d_mode;
 }

 function getSerializeKey() {
 $rs["parent"] = parent::getSerializeKey();
 $rs["tabs"] = $this->d_tabs;
 $rs["mode"] = $this->d_mode;
 $rs["icons"] = $this->d_icons;
 $rs["fullTabs"] = $this->d_fullSizedTabs;
 return $rs;
 }

 function initFromSerializeKey( $key ) {
 parent::initFromSerializeKey( $key["parent"] );
 $this->d_tabs = $key["tabs"];
 $this->d_mode = $key["mode"];
 $this->d_icons = $key["icons"];
 $this->d_fullSizedTabs = $key["fullTabs"];
 }


 function getFocusableElementName()
 {
 $ele = $this->getActiveTabComponent();
 $name = $ele->getFocusableElementName();
 if ( $name ) return $this->getActiveTabName() . $name;
 return NULL;
 }


 function getHTML( &$form, $prefix, $doCheck, $checkSeverity, $partKey ) {

 global $STAG_PREFIX;
 $bgcolor = "#CECECE";
 
 
 if ( $doCheck && $this->isError() )
 {
 $eKey = $this->getFirstErrorElementKey();
 if ( $eKey )
 $this->setActiveTab( $eKey );
 }

 
 $tabs = array();
 $started = false;
 $active = false;
 
 
 $tabs[] = array("t"=>"c", "v"=>6);
 
 reset($this->d_tabs);
 $aT = $this->getActiveTabName();
 $cols = 4;
 if ($this->d_fullSizedTabs) $smallspacing = "";
 else $smallspacing = "width=1%"; 

 
 
 while (list($key, $lbl) = each($this->d_tabs)) {
 if ( $this->d_icons[$key] ) {
 $lbl = img($this->d_icons[$key],0,"","","","","","vertical-align: middle")."&nbsp;".$lbl;
 }
 if ( $key == $aT ) {
 if ($started) { $tabs[] = array("t"=>"l", "v"=>2); $cols++; }
 $tabs[] = array("t"=>"c", "v"=>2);
 $cols += 2;
 $active = true;
 $title = "<li class=\"active\"><span>$lbl</span></li>";
 } else {
 if (!$started) $v = 1;
 else if ($active) $v = 3;
 else $v = 4;
 $tabs[] = array("t"=>"c", "v"=>$v);
 $cols += 2;
 if ($started) { $tabs[] = array("t"=>"l", "v"=>2); $cols++; }
 $active = false;
 $actionJS[$key] = $form->getJsActionCall(new ValueSetterFormAction($partKey, "activeTab", $key));
 $title = "<li><a href=\"javascript:$actionJS[$key]\">$lbl</a></li>";
 }

 $h = "$title";
 $tabs[] = array("t"=>"l", "v"=>($active?1:0), "h"=>$h);
 $cols++;
 $started = true;
 }

 $tabs[] = array("t"=>"c", "v"=>($active?3:5));
 $tabs[] = array("t"=>"c", "v"=>7);

 
 $prev = $this->getPrevTabName();
 $next =$this->getNextTabName();
 $this->setShortcut( VK_KP_SLASH | VK_MOD_SHIFT, $actionJS[$prev] );
 $this->setShortcut( VK_KP_STAR | VK_MOD_SHIFT, $actionJS[$next] );

 
 $header = "<div class=\"tabs\"><ul class=\"tabs\">";
 for ($row = 0; $row <=5; $row++) {
 reset($tabs);
 while (list($k, $v) = each($tabs)) {
 switch ($v["t"]) {
 case "c": $header .= $corner[$v["v"]][$row]; break;
 case "l": $header .= ($row == 3)?$v["h"]:$line[$v["v"]][$row]; break;
 }
 }
 }
 $header .= "</ul></div>";

 $tab = $this->_getComponentHTMLTable( $aT, $form, $prefix, $doCheck, $checkSeverity, $partKey, false, "width=100%" );

 $otab = "";
 if (is_array($tab)) {
 foreach($tab as $lbl=>$val) {
 $otab .= "<tr valign=\"top\"><td width=\"100\">$lbl</td><td><nobr>$val</nobr></td></tr>\n";
 }
 } else $otab = $tab;
 
 $content = $otab; 
 if( $this->getShowOnlyContent() ) return $content;
 $html .= $header; 
 $html .= "
			<table border=0 cellpadding=0 cellspacing=0 class=\"table\">
				<tbody>
					<tr>
						<td class=\"spacer\">&nbsp;</td>
					</tr>

					<tr>
						<td width=10>$ico_bottom</td>
						<td valign=top>$content</td>
					</tr>
				</tbody>
			</table>\n"; 
 
 $rs = $this->mergeResult( parent::getHTML( $form, $prefix, $doCheck, $checkSeverity, $partKey ), $html );
 return $rs;
 }
}
?>