<?php
GUIFactory::setMainGUI( "main" );


if ($USER_ID != 1 && !perm($USER_ID, T_CONTENT, null, 0)) {
 halt(7, "no perms to view nodes");
}

if ($USER_ID != 1 && !perm($USER_ID, T_DOMAIN, $FOLDER_ID, 0) && !perm($USER_ID, T_DOMAIN_CHANNEL, $FOLDER_ID, 0)) {
 halt(7, "no perms to view features of root folder $FOLDER_ID");
}


$folderinfo = get_folderinfo($FOLDER_ID);
$NODE_ID = $folderinfo["node_id"];
$name = $folderinfo["name"];

$nodeForm = new HtmlForm3("node");
if ($nodeForm->isNew()) {
 if (!$redo) {
 $redo = 11012;
 }

 
 $active = getFeatures($NODE_ID);

 $nodeForm->setHeader(i18n("features.of.node", 0, $name));
 $main = new ListComponent();
 $nodeForm->addComponent('main', $main);

 $main->setComponent('redo', new HiddenComponent($redo));
 $main->setComponent('nodeid', new HiddenComponent($NODE_ID));

 $node_features = getActivatedNodeFeatures();
 
 foreach ($node_features as $feature) {
 $main->setComponent("f_$feature", $comp = new CheckBoxComponent($feature, in_array($feature, $active)));
 $comp->setHelp(i18n("feature.$feature.help"));
 }

 $nodeForm->addButton('ok', new Button(i18n("OK")), new SimpleFormAction("setFeatures"), true);
 $nodeForm->addButton('cancel', new Button(i18n("cancel"), false ), new RedoFormAction($redo), false);
}




function setFeatures(&$form) {
 global $CN_LOCAL_SERVER, $PORTLETAPP_PREFIX_INTERNAL, $SESSION_TOKEN, $REDO;

 
 $nodeId = $form->resolveComponent("main.nodeid")->getValue();

 $node_features = getActivatedNodeFeatures();
 $active = array();
 foreach ($node_features as $feature) {
 if ($form->resolveComponent("main.f_$feature")->isChecked()) {
 $active[] = $feature;
 }
 }

 $request = array("features" => $active);

 $fc = new fetchCurl();
 $fc->setUrl($CN_LOCAL_SERVER . $PORTLETAPP_PREFIX_INTERNAL . "rest/node/features/set/$nodeId?sid=$SESSION_TOKEN");
 $fc->setSubmitType("POST");
 $fc->setPostData(json_encode($request));
 $fc->setHeader("Content-Type", "application/json");
 $json = $fc->doRequest();

 if ($fc->getReturnCode() == '') {
 halt(7,'Unable to connect to CNPortletapp for setting features');
 } else if ($fc->getReturnCode() >= 400) {
 halt(120, 'Accessing CNPortletapp returned error '.$fc->getReturnCode());
 }

 $redo = $form->resolveComponent("main.redo")->getValue();
 $REDO = $redo;
}






function getFeatures($nodeId) {
 global $CN_LOCAL_SERVER, $PORTLETAPP_PREFIX_INTERNAL, $SESSION_TOKEN;

 $fc = new fetchCurl();
 $fc->setUrl($CN_LOCAL_SERVER . $PORTLETAPP_PREFIX_INTERNAL . "rest/node/features/$nodeId?sid=$SESSION_TOKEN");
 $json = $fc->doRequest();

 
 if ($fc->getReturnCode() == '') {
 halt(7,'Unable to connect to CNPortletapp for setting features');
 } else if ($fc->getReturnCode() >= 400) {
 halt(120, 'Accessing CNPortletapp returned error '.$fc->getReturnCode());
 }

 $response = json_decode($json, true);
 return $response["features"];
}


