<?php

class CNTagStruct extends CNObject {

 function CNTagStruct() {
 parent::CNObject();
 }

 



 function &getValues() {
 }
 function &getParts() {
 }

}

class CNTagObject extends CNTagStruct {

 var $tagtype;
 var $d_tagId;
 var $d_initialized = FALSE;

 function CNTagObject($tagtype, $id = 0) {
 parent::CNTagStruct();
 $this->tagtype = $tagtype;
 $this->setID($id);
 }

 function getTagType() {
 return $this->tagtype;
 }

 function getTagTable() {
 return $this->tagtype."tag";
 }

 function getTType () {
 global $T_TAG;
 return $T_TAG;
 }
 
 function getID() {
 return (int) $this->d_tagId;
 }
 
 function _setID($id) {
 $this->d_tagId = $id;
 }

 function setMother (&$mothertag) {
 $this->setObjectRef( "mother", $mothertag );
 }

 function &getMother() {
 return $this->getObjectRef( "mother" );
 }
 
 function getName() {
 return $this->getFieldValue("name");
 }

 function getObjectKey() {
 return $this->getFieldValue("name");
 }

 function isVisible() {
 return $this->getFieldValue("enabled");
 }

 function setVisible( $isVisible ) {
 $this->setFieldValue( "enabled", $isVisible?1:0 );
 }

 function _initPartsAndValues() {
 global $T_PART;
 if (!$this->d_initialized) {
 
 node_class( "sqljointable" );
 $joinTable = new SqlJoinTable( array( new SqlTable( "part" ), new SqlTable( "value" ) ),
 array(),
 array( "value"=>array( "type"=>JOIN_LEFT,
 "cond"=>"value.part_id=part.id AND value.".sqlf_name($this->getTagType())."tag_id=".sqlf_tl_num($this->getID()) 
 )
 ) );
 $result = $joinTable->findBy( "part.construct_id", $this->getConstructID(),
 "=", array( "part.partorder"=>ORDER_ASC ) );
 $partColl = new NodeObjectCollection($T_PART);
 $valueColl = new NodeObjectCollection($T_VALUE);
 foreach ( $result as $r )
 {
 $part = $r["part"];
 $val = $r["value"];

 unset($o_part);
 $o_part = new CNPartObject( $part->getValue("id") );
 $o_part->setMother($this);
 $o_part->initFromResultSet( $part->getHash() );
 $partColl->add( $o_part );

 unset($o_value);
 if ( $val->getValue("id") !== NULL )
 {
 $o_value = new CNValue( $val->getValue("id") );
 $o_value->initFromResultSet( $val->getHash() );
 }
 else
 {
 $o_value = new CNValue();
 }
 $o_value->setPartObject( $o_part );
 $valueColl->add( $o_value );
 
 }
 $this->setObjectRef( "tagparts", $partColl );
 $this->setObjectRef( "tagvalues", $valueColl );
 








 $this->d_initialized = true;
 }
 return TRUE;
 }

 function getValueFields() {
 return array( "name"=>"text" );
 }
 
 function _getNodeTable() { 
 return $this->getTagType()."tag"; 
 }

 function getPropertyNames() {
 return array_merge( parent::getPropertyNames(), array( 
 "name"=>i18n("Name"),
 "tagtype"=>i18n( "Tagtyp" ),
 "parts" => i18n( "Parts" ),
 "value" => i18n( "Value" ),
 "versions" => i18n( "Versions" )
 ) );
 }
 
 function &getParts()
 {
 $this->_initPartsAndValues();
 return $this->getObjectRef( "tagparts" ); 
 }
 
 function &getProperty($key) {
 static $tagbuilder = NULL;
 $obj = false;
 $key = strtolower($key);
 switch ($key) {
 case "name":
 $obj = new StringObject($this->getFieldValue("name"));
 break;
 case "tagtype":
 $obj = new StringObject($this->getTagType());
 break;
 case "parts":
 return $this->getParts();
 break;
 case "value":
 $this->_initPartsAndValues();
 if ( $tagbuilder === NULL )
 {
 node_class( "cntagbuilder" );
 $tagbuilder = new CNTagBuilder();
 }
 $obj =& $tagbuilder->buildTagParts( $this, $this->getMother() );
 break;
 default:
 $obj =& parent::getProperty($key);
 }
 return $obj;
 }

 function getXML($level = 0, $prefix = '') {
 $this->_initParts();
 $xml = $prefix.'<tag>'."\n";
 $xml .= $prefix.'  <id>'.$this->getID().'</id>'."\n";
 $xml .= $prefix.'  <name>'.$this->getFieldValue("name").'</name>'."\n";
 $xml .= $prefix.'  <type>'.$this->tagtype.'</type>'."\n";
 $xml .= $prefix.'  <parts>'."\n";

 $parts =& $this->getProperty("parts");
 $i = $parts->iterator();
 while ($i->hasNext()) {
 $next = $i->next();
 $xml .= $next->getXML($level + 1, $prefix.'  ');
 }
 $xml .= $prefix.'  </parts>'."\n";
 $xml .= $prefix.'</tag>'."\n";
 return $xml;
 }

 function &getValues() {
 if (!$this->_initPartsAndValues()) return NULL;
 return $this->getObjectRef( "tagvalues" );
 }






















 function getConstructID() {
 return $this->getFieldValue("construct_id");
 }

 function &getConstruct() {
 return new CNConstruct( $this->getConstructID() );
 }

 function &getFormObject() {
 return new CNTagFormObject($this);
 }

 function getDisplayName() {
 $construct = &$this->getConstruct();
 $constructName = $construct->getName();
 $icon = $construct->getIcon();
 return i18n("tagtype_singular") . " " . img( $icon, 0, '', '', '', '', '', '', '', 'vertical-align:middle;' ) . " " . $constructName;
 }
}

class CNContentTagObject extends CNTagObject {

 function CNContentTagObject( $id = 0 ) {
 parent::CNTagObject("content", $id);
 }

 function getValueFields() {
 return array("content_id"=>false, "construct_id"=>false, "name"=>"text", "enabled"=>"bool");
 }

 function _getNodeTable() { return "contenttag"; }

 function getDisplayName() {
 $super = parent::getDisplayName();
 $name = $this->getFieldValue("name");
 $construct = &$this->getConstruct();
 $icon = $construct->getIcon();
 return i18n("Tag") . " " . img( $icon, 0, '', '', '', '', '', '', '', 'vertical-align:middle;' ) . " " . $name . ", " . $super;
 }
}

class CNTemplateTagObject extends CNTagObject {

 function CNTemplateTagObject( $id = 0 ) {
 parent::CNTagObject("template", $id);
 }

 function getValueFields() {
 return array("template_id"=>false, "construct_id"=>false, "name"=>"text", "enabled"=>"bool", "pub"=>false, "templategroup_id"=>false);
 }

 function _getNodeTable() { return "templatetag"; }

 function getDisplayName() {
 $super = parent::getDisplayName();
 $name = $this->getFieldValue("name");
 $construct = &$this->getConstruct();
 $icon = $construct->getIcon();
 return i18n("Tag") . " " . img( $icon, 0, '', '', '', '', '', '', '', 'vertical-align:middle;' ) . " " . $name . ", " . $super;
 }
}

class CNObjectTagObject extends CNTagObject {

 function CNObjectTagObject( $id = 0 ) {
 parent::CNTagObject("obj", $id);
 }

 function getValueFields() {
 return array("obj_id"=>false, "obj_type"=>false, "construct_id"=>false, "name"=>"text", "enabled"=>"bool", "intag"=>false);
 }

 function _getNodeTable() { return "objtag"; }

 function getDisplayName() {
 global $ICO_OBJPROP;
 $super = parent::getDisplayName();
 $name = $this->getFieldValue("name");
 return i18n("Objectproperty") . " " . img( $ICO_OBJPROP, 0, '', '', '', '', '', '', '', 'vertical-align:middle;' ) . " " . $name . ", " . $super;
 }
}

class CNConstruct extends CNTagStruct {
 var $d_constructId;
 var $d_partsInitialized;
 var $d_valuesInitialized = FALSE;

 function CNConstruct( $id = 0 ) {
 parent::CNTagStruct();
 $this->setID($id);
 $this->setViewLinkParams("do=10013&cmd=update&cid=" . $this->getId());
 }

 function getTType () {
 global $T_CONSTRUCT;
 return $T_CONSTRUCT;
 }
 
 function getID() {
 return (int)$this->d_constructId;
 }

 function _setID($id) {
 $this->d_constructId = $id;
 }

 function &getValues() {
 if (!$this->_initValues()) return NULL;
 return $this->getObjectRef( "cvalues" );
 }

 function _initValues() {
 global $T_VALUE;
 if (!$this->d_valuesInitialized) {
 $coll = new Collection();
 $sql = "SELECT value.*, part.id as partid FROM part left join value ".
 "ON (part.id = value.part_id AND value.static=1) ".
 "WHERE part.construct_id = ".sqlf_tl_num($this->getID()); 
 $rs = query( $sql, true);
 foreach ( $rs["arr"] as $value )
 {
 unset($o_value);
 $o_value = new CNValue( $value['id'] );
 $o_value->initFromResultSet($value);
 $o_value->setPartId( $value["partid"] );
 $coll->add( $o_value );
 }
 $this->setObjectRef( "cvalues", $coll );
 $this->d_valuesInitialized = true;
 }
 return true;
 }

 function &getParts() {
 if (!$this->_initParts()) return NULL;
 return $this->d_parts;
 }

 function _initParts() {
 global $T_PART;
 if (!$this->d_partsInitialized) {
 $coll = new NodeObjectCollection($T_PART);
 $sql = 'SELECT * FROM part WHERE construct_id = '.sqlf_tl_num($this->getID());
 $rs = query( $sql, true);
 foreach ( $rs["arr"] as $value )
 {
 $o_part = new CNPartObject( $value['id'] );
 $o_part->setMother($this);
 $o_part->initFromResultSet($value);
 $coll->add( $o_part );
 }
 $this->setObjectRef( "cparts", $coll );
 $this->d_partsInitialized = true;
 }
 return true;
 }

 function needsClosingTag() {
 static $needsClosingTag = NULL;

 if ($needsClosingTag === NULL) {
 $needsClosingTag = false;
 $parts =& $this->getParts();
 $i =& $parts->iterator();
 while ($i->hasNext()) {
 $part =& $i->next();
 $parttype =& CNPartTypeFactory::getPartType($part->getPartTypeID());
 $needsClosingTag = $needsClosingTag || $parttype->needsClosingTag();
 }
 }
 return $needsClosingTag;
 }

 function getValueFields()
 {
 return array(
 "icon"=>false, "name_id"=>"int", "category_id"=>"int"
 );
 }

 function getIcon()
 {
 return tag_icon($this->getFieldValue( "icon" ));
 }

 function getName()
 {
 return $this->_idToDicUser( $this->getFieldValue("name_id") );
 }
 
 function _getNodeTable()
 {
 return "construct";
 }

 function getParentTType() {
 return array(T_CONSTRUCTS);
 }

 function getCategoryName() {
 $category_id = $this->getFieldValue("category_id");
 if ($category_id > 0) {
 $category = NodeFactory::getStaticInstanceOf(T_CONSTRUCT_CATEGORY, $category_id);
 return $category->getName();
 }
 return null;
 }

 function _checkPermission($parentObjectType, $parentObjectId) {
 
 
 return true;
 }

 function _checkSearchTerm($searchTerm) {
 if (! $searchTerm) {
 return true;
 }
 $prettyName = $this->getName();
 if (strpos(strtolower($prettyName), strtolower($searchTerm)) !== FALSE) {
 return true;
 }
 return false;
 } 
 function _getBaseFilter() {
 return get_visible_constructs("id");
 }

 function _getSearchFilter($searchTerm) {
 return null;
 }

 function dirt( $id, $eventType = EVENT_UPDATE )
 {
 triggerEvent(T_CONSTRUCT, $id, $eventType, new EventObject() );
 }
 
 function onStaticEventNotify( $TType, $id, $changeType, $eventObject, $depth, $simulate ) 
 {
 global $T_SOURCE;
 if ($simulate && $simulate > 0) return;
 switch ( $TType )
 {
 case $T_SOURCE:
 





 if ($changeType & (EVENT_UPDATE | EVENT_CREATE)) {
 $sql = "select id, type_id from part where type_id in (29,30) and info_int=".sqlf_tl_num($id);
 $rs = query($sql);
 foreach ($rs["arr"] as $row) {
 $partType = CNPartTypeFactory::getPartType($row["type_id"]);
 $partType->cleanupParts($row["id"]);
 }
 }
 
 if ($eventObject->getProperty("doSync")) {
 $sql = "select distinct construct_id from part where type_id in (29,30) and info_int=".sqlf_tl_num($id);
 $rs = query( $sql );
 foreach ( $rs["arr"] as $row )
 {
 CNConstruct::dirt( $row["construct_id"], EVENT_UPDATE | EVENT_CN_CONTENT );
 }
 }
 
 break;
 }
 }

 function delete() {
 return construct_del(array($this->getID() => true));
 }
}

class CNConstructCategory extends NodeObject {

 var $id;

 function CNConstructCategory($id) {
 parent::NodeObject($id);
 $this->setViewLinkParams("do=10016&argcategory=" . $this->getId());
 }

 function _getNodeTable() {
 return "construct_category";
 }

 function getTType() {
 return T_CONSTRUCT_CATEGORY;
 }

 function getValueFields() {
 return array("name_id"=>"int", "id"=>"int");
 }

 function getIcon() {
 global $ICO_CONSTRUCT;
 return $ICO_CONSTRUCT;
 }
 
 function getName() {
 $name_id = $this->getFieldValue("name_id");
 if ($name_id) {
 return $this->_idToDicUser( $this->getFieldValue("name_id") );
 }
 return i18n("Other");
 }

 function getDisplayName() {
 return $this->getName();
 }

 function _setID($id) {
 $this->id = $id;
 }

 function getID() {
 return $this->id;
 }
}

class CNTagFormObject extends NodeFormObject {

 function CNTagFormObject ( &$tagObject ) {
 parent::NodeFormObject( $tagObject );
 
 $partCollection = $tagObject->getParts();
 $it = &$partCollection->iterator();
 while ( $it->hasNext() )
 {
 unset( $o_part );
 $o_part =& $it->next();
 if ( !$o_part->isEditable() )
 $it->remove();
 }
 
 $this->setObjectRef( "tagParts", $partCollection );
 }

 function &getTagParts()
 {
 return $this->getObjectRef( "tagParts" );
 }
 
 function isNew() {
 $nodeObject = &$this->getEditObject();
 return $nodeObject->isNew();
 }
 
 function getValueFields() {
 $ret = array();
 $tagParts =& $this->getTagParts();
 $it = &$tagParts->iterator();
 while ( $it->hasNext() )
 {
 $it->next();
 $ret["t".$it->getKey()] = false;
 }
 $ret["visible"] = false;
 $nodeObject = &$this->getEditObject();
 $ret["new"] = false;
 return $ret;
 }

 function save() {
 echo "saving myself :)";
 parent::save();
 $tagParts =& $this->getTagParts();
 $it = &$tagParts->iterator();
 while ( $it->hasNext() )
 {
 unset($obj);
 $obj =& $it->next();
 $obj->save();
 }
 }

 function getStoredFieldValue($field) {
 }
 
 function &getFieldValue($field) {
 }
 
 function setFieldValue($field, $value, $initOnly = false) {
 }
 
 
 
 






 function getListHeaders() { return array(); }
 
 


 function getFieldDescriptions() { return array(); }

 function getFieldLabels() {
 }
 
 




 function isEditableField($field) { 
 return true;
 }

 function isOptionalField($field) { 
 }

 




 function &getFormComponent($field) {
 switch ( $field )
 {
 case "visible":
 $obj =& $this->getEditObject();
 node_class( "checkboxcomponent" );
 $ret = new CheckboxComponent( "sichtbar", $obj->isVisible() );
 break;
 case "new":
 global $NODE_ID, $LANGUAGE;
 $where = get_visible_constructs("construct.id",$NODE_ID);
$sql = "SELECT value AS name, construct.id, LOWER(value) AS l_value FROM construct LEFT JOIN dicuser ON (dicuser.output_id = construct.name_id AND dicuser.language_id = ".sqlf_tl_num($LANGUAGE).") WHERE $where AND construct.intext = 1 ORDER BY l_value";
$rs = query($sql);
$constructs = $rs["arr"];
$constructs = reduce_array($constructs,"id","name");
 
 $obj =& $this->getEditObject();

 $ret = new ListComponent();
 $sel = new SelectComponent( "Neuer Tag", $constructs );
 $sel->setOptional( true ); 
 
 $param = array( "id"=>$obj->getID(), "tagtable"=>$obj->getTagTable(),
 "tagtype"=>$obj->getTagType() );
 $sel->setOnChangeAction( new SimpleClassFormAction( "CNTagFormObject", "insertTagAction", $param ) );

 $tag = new TextComponent( );
 $tag->setOptional( true );
 $tag->setVisible( false );
 
 $ret->setComponent( "s", $sel );
 $ret->setComponent( "t", $tag );
 break;
 default:
 $parts =& $this->getTagParts();
 $nodeObject = &$parts->getByKey(substr($field,1));
 $ret = &$nodeObject->getFormComponent();
 }
 return $ret;
 }

 function insertTagAction( &$form, $param ) {
 echo "TODO: implement better way for fetching object-editor-form-components<br>\n";
 
 $c =& $form->getComponent( "fnew" );
 $selC =& $c->getComponent( "s" );
 $selC->clearSelection();
 $tagC =& $c->getComponent( "t" );
 $tagC->setVisible(true);
 
 $tmp = cmd_tag_generate($selC->getSelection(),$param["id"],$param["tagtable"],
 $param["tagtype"]);

 $tagC->setText( $tmp["name"] );
 }
 
 


 function storeFormComponent($field, &$component) { 
 switch ( $field )
 {
 case "visible":
 $obj =& $this->getEditObject();
 $obj->setVisible( $component->isChecked() );
 break;
 default:
 $parts =& $this->getTagParts();
 $nodeObject = &$parts->getByKey(substr($field,1));
 if( !is_a( $nodeObject, "nodeexception" ) )
 $nodeObject->storeFormComponent($component);
 }

 }
}


 
 
?>
