<?php






function convertToFilename($filename) {

 global $FEATURE;
 global $SANITIZE_CHARACTER;
 
 if (!$filename) {
 return $filename;
 }

 $maxFilenameLength = 64;
 
 $allowedCharactersRegex = "/[^\s\w\.\-\(\)\[\]{}\$]/";
 $replacementCharacter = '_';

 if( $FEATURE['filename_forcetolower'] ) {
 $filename = strtolower($filename);
 }
 
 
 
 
 
 
 if ($FEATURE['UTF8']) {
 $filename = htmlentities($filename, ENT_QUOTES, 'UTF-8');
 }
 
 $sanitizeKeys = array_keys($SANITIZE_CHARACTER);
 foreach ($sanitizeKeys as $key => $value) {
 $sanitizeKeys[$key] = htmlentities($value, ENT_QUOTES, 'UTF-8');
 }
 
 
 $filename = str_replace(
 $sanitizeKeys,
 array_values($SANITIZE_CHARACTER),
 $filename
 );
 
 
 $filename = preg_replace('/&[^s]*;/i', "_", $filename);
 
 if ($FEATURE['UTF8']) {
 $filename = html_entity_decode($filename,ENT_COMPAT, 'UTF-8');
 }
 
 $filename = preg_replace($allowedCharactersRegex, $replacementCharacter, $filename);
 
 
 if (strlen($filename) > $maxFilenameLength) {

 $pathInfo = pathinfo($filename);

 if (isset($pathInfo['extension'])) {
 $extension = $pathInfo['extension'];
 }
 else {
 $extension = "";
 }

 
 
 if (!isset($pathInfo['filename'])){
 $pathInfo['filename'] = substr($pathInfo['basename'], 0, strpos($pathInfo['basename'], '.'));
 }

 $hasExtension = (strlen($extension) > 0 || substr($pathInfo['filename'], -1) == '.');
 $newFileNameLength = $maxFilenameLength - strlen($extension);

 if ($hasExtension) {
 $newFileNameLength--;
 }

 if ($newFileNameLength > 0) {
 $filename = substr($pathInfo['filename'], 0, $newFileNameLength);

 if ($hasExtension) {
 $filename .= '.' . $extension;
 }
 }

 if (strlen($filename) > $maxFilenameLength) {
 
 $filename = substr($filename, 0, $maxFilenameLength);
 }
 }

 return $filename;
}
