<?php
GUIFactory::setMainGUI("shell");
node_class( "sqltable" );
node_class( "userformatter" );
node_class( "dateformatter" );
node_class( "timeobject" );
node_class( "scheduler" );
node_include( "scheduletype" );







$code = 200;
$code_message = "OK";

$schedulerStatusActions = array(
 "resume",
 "suspend",
 "status"
);


$message = "";


if (!$id && !$action || !$id && !in_array($action,$schedulerStatusActions)) {
 $code = 400;
 $code_message = "Bad Request";
 $message = "No job id or valid action given";
} else {
 if ($id) {
 
 $rs = query("select * from job where id = '".sqlf_escaped($id)."'");
 if ($rs["num"] == 0) {
 $code = 404;
 $code_message = "Not Found";
 $message = "No job found with id $id.";
 } else {
 $job = $rs["arr"][0]["id"];
 }
 } 
}

if ($id) {
 if ($code == 200 && $action && $action != "activate" && $action != "deactivate" && $action != "status" && $action != "run") {
 $code = 400;
 $code_message = "Bad Request";
 $message = "Given action '$action' not valid. Possible actions are: 'activate', 'deactivate', 'status', 'run'.";
 unset($job);
 }
}

if ($id) {
 
 if ($code == 200 && !perm($USER_ID, T_TASKADMIN, "", 12) && !perm($USER_ID, T_JOB, $id, 0)) {
 $code = 403;
 $code_message = "Forbidden";
 $message = "Access forbidden";
 unset($job);
 }
} else {
 
}

if ($action == "activate" && $code == 200) {
 if (perm( $USER_ID, T_TASKADMIN, "", 13) ) {
 job_activate($id);
 $message = "Job $id was successfully activated.";
 } else {
 $code = 403;
 $code_message = "Forbidden";
 $message = "Access forbidden";
 }
} else if ($action == "deactivate" && $code == 200) {
 if (perm( $USER_ID, T_TASKADMIN, "", 13) ) {
 job_deactivate($id); 
 $message = "Job $id was successfully deactivated.";
 } else {
 $code = 403;
 $code_message = "Forbidden";
 $message = "Access forbidden";
 }
} else if ($action == "run" && $code == 200) {
 if (perm( $USER_ID, T_TASKADMIN, "", 13) ) {
 job_runnow($id); 
 $message = "Job $id was successfully scheduled to run.";
 } else {
 $code = 403;
 $code_message = "Forbidden";
 $message = "Access forbidden";
 }

} else if ($action == "suspend" && $code == 200) {
 $message = "suspending";
 Scheduler::suspend($ignoreJobs);
} else if ($action == "resume" && $code == 200 && !$job) {
 $message = "resuming";
 Scheduler::resume();
} else if ($action == "status" && $code == 200 && !$job) {
 $schedulerStatus = Scheduler::getStatus();
 switch ($schedulerStatus) {
 case SCHEDULER_STATUS_RUNNING:
 $message = "running";
 break;
 case SCHEDULER_STATUS_SUSPENDING:
 $message = "suspending";
 break;
 case SCHEDULER_STATUS_SUSPENDED:
 $message = "suspended";
 break;
 }
}

if ($job) {
 $jobTable = new SqlTable( "job" );
 $jobs = $jobTable->findBy( "id", $job );

 $job = $jobs[0];
 $creator = new UserFormatter( "creator", USERINFO_NAME );
 $created = new DateFormatter( "cdate" );
 $editor = new UserFormatter( "editor", USERINFO_NAME );
 $edited = new DateFormatter( "edate" );

 $status = job_status( getJobStatus( $job ) );

 $runTable = new SqlTable( "jobrun" );
 $lastruns = $runTable->findBy( array("id"), array($job->d_values["last_valid_jobrun_id"]), false, "starttime DESC", 1);
 if ( count($lastruns) > 0 ) {
 $format = i18n('LOCALIZED_DATEFORMAT');
 if ( $format == 'LOCALIZED_DATEFORMAT' ) {
 $format = 'd.m.Y';
 }
 $lastrun = new DateFormatter( "starttime" );
 $lastrun_time = $lastrun->format( $lastruns[0]->d_values );
 $lastrun_status = !$lastruns[0]->getValue("returnvalue") ? "OK" : "Failed";
 $end = $lastruns[0]->getValue( "endtime" );
 $start = $lastruns[0]->getValue( "starttime" );
 if ( $start >0 && $end > 0 ) {
 $lastrun_duration = TimeObject::formatTimeDiffHours( $end - $start );
 } else {
 $lastrun_duration = TimeObject::formatTimeDiffHours( time() - $start );
 }
 } else {
 $lastrun_time = "";
 $lastrun_status = "";
 $lastrun_duration = "";
 }
 $runs = $job->getValue("jobruncount");
 $average_duration = TimeObject::formatTimeDiffHours($job->getValue("jobrunaverage"));
}

function job_activate( $id ) {
 global $USER_ID;

 $sql = "UPDATE job SET status=1 WHERE id=".sqlf_tl_num($id);
 query( $sql );

 $sql = "UPDATE job SET editor=".sqlf_tl_num($USER_ID)." where id=".sqlf_tl_num($id);
 query ($sql);

 $sql = "UPDATE job SET edate='".sqlf_escaped(time())."' where id=".sqlf_tl_num($id);
 query ($sql);
}

function job_deactivate( $id ) {
 global $USER_ID;

 $sql = "UPDATE job SET status=0 WHERE id=".sqlf_tl_num($id);
 query( $sql );

 $sql = "UPDATE job SET editor=".sqlf_tl_num($USER_ID)." where id=".sqlf_tl_num($id);
 query ($sql);

 $sql = "UPDATE job SET edate='".sqlf_escaped(time())."' where id=".sqlf_tl_num($id);
 query ($sql);
}

function job_status( $status ) {
 switch ( $status ) {
 case JOBSTATUS_INACTIVE:
 return "inactive";
 case JOBSTATUS_WAITING:
 return "waiting";
 case JOBSTATUS_RUNNING:
 return "running";
 case JOBSTATUS_DONE:
 return "done";
 case JOBSTATUS_DUE:
 return "due";
 case JOBSTATUS_INACTIVE_RUNNING:
 return "inactive-running";
 case JOBSTATUS_INVALID:
 return "invalid";
 default:
 return "N/A";
 }
}

function job_runnow( $id )
{
 global $FEATURE, $scheduleTypeClasses;

 node_class( "sqltable" );
 $jobtable = new SqlTable ( "job" );
 $jobs = $jobtable->findBy( "id", $id );
 $job = $jobs[0];

 $class = $scheduleTypeClasses[$job->getValue("schedule_type")]; 

 $class->loadData( node_unserialize($job->getValue( "schedule_data" )) );
 $class->performAction( "runnow" );
 $job->setValue( "schedule_data", node_serialize($class->getData()) );
 $job->save();
 if( $FEATURE['spawn_scheduler_on_interact'] ) {
 spawnNewScheduler();
 }
}

?>
