<?php

if (!isset($USER_PERM)) $USER_PERM = array();
if (!isset($GROUP_PERM)) $GROUP_PERM = array();
if (!isset($DUPLICATE_PERM)) $DUPLICATE_PERM = array();


function perm_grant_all($type, $id, $user_id=false, $perm = "11000000111111111111111111111111")
{
 
 if ($perm === "00000000000000000000000000000000") {
 return;
 }
 global $USER_ID;
 if ( !$user_id ) $user_id = $USER_ID;
 $groups = user_getmothergroups($user_id);

 if ($groups) {
 while (list($key,$val) = each($groups)) {
 $sql = "INSERT INTO perm (usergroup_id,o_type,o_id,perm) VALUES (".sqlf_tl_num($key).",".sqlf_tl_num($type).",".sqlf_tl_num($id).",'".sqlf_escaped($perm)."')";
 query($sql);
 }
 }

 node_include("codeparser");
 $javaParser =& CodeParser::getJavaParser();
 $javaParser->refreshPerms($type, $id);
}


function perm_set_perms($group_id,$o_type,$o_id,$perm) {
 global $USER_PERM, $GROUP_PERM, $USERGROUP_PERM, $T_FOLDER, $T_NODE;

 if (!$group_id) halt(101,"perms_set_perms: No Group_id ($group_id)");
 if (!$o_type) halt(101,"perms_set_perms: No o_type ($o_type)");
 if (!$o_id) halt(101,"perms_set_perms: No o_id ($o_id)");
 if (is_array($perm)) halt(101,"perms_set_perms: Perm is an array.");
 
 $sql = "DELETE FROM perm WHERE usergroup_id = ".sqlf_tl_num($group_id)." AND o_type = ".sqlf_tl_num($o_type)." AND o_id = \"".sqlslashes($o_id)."\"";
 query($sql);

 
 if ($perm !== "00000000000000000000000000000000") {
 $sql = "INSERT INTO perm (usergroup_id,o_type,o_id,perm) VALUES (".sqlf_tl_num($group_id).",".sqlf_tl_num($o_type).",\"".sqlslashes($o_id)."\",'".sqlf_escaped($perm)."')";
 query($sql);
 }

 if ($o_type == $T_FOLDER || $o_type == $T_NODE) {
 triggerEvent( $T_FOLDER, $o_id, EVENT_UPDATE, new EventObject(null, array("permissions")) );
 }

 unset($USER_PERM[$o_type][$o_id]);
 unset($GROUP_PERM[$o_type][$o_id]);
 $USERGROUP_PERM = array();

 node_include("codeparser");
 $javaParser =& CodeParser::getJavaParser();
 $javaParser->refreshPerms($o_type, $o_id);
}


function private_perms(&$permarray,$sql,$id,$o_type,$o_id=-1,$bit=-1) {
 global $DEBUG, $USER_ID;

 
 if ($bit > -1) $error = 0; else $error = array(0);
 
 
 
 
 if (!($id > 0)) return $error;
 if ($o_type == "") return $error;

 if (is_array($permarray[$o_type]["$o_id"][$id])) {
 $arr = $permarray[$o_type]["$o_id"][$id];

 } else {
 
 $rs = query($sql,1);

 
 if ($rs["num"] == 0) return $error;

 
 $is_not_null = FALSE;

 $arr = array();

 for ($i = 0; $i < $rs["num"]; $i++) {
 $perm = $rs["arr"][$i]["perm"];

 
 if (ereg("^[0-1]*$",$perm)) {
 $c = strlen($perm);

 for ($j = 0; $j < $c; $j++) {
 $set = substr($perm,$j,1);
 if (!isset($arr[$j])) $arr[$j] = 0;
 $arr[$j] = max($set,$arr[$j]);
 }

 
 $is_not_null = TRUE;
 }
 }

 
 if (!$is_not_null) return $error;

 
 $permarray[$o_type]["$o_id"][$id] = $arr;
 }

 
 if ($bit >= count($arr)) return 0;

 if ($bit > -1) $ret = $arr[$bit]; else $ret = $arr;

 if ($DEBUG["perm"]) {
 echo "PERMS: TYPE($o_type) ID($o_id) bit($bit) Vardump: ";
 if ($bit > -1) echo "RET($ret)<br>\n"; else {
 for ($i = 0; $i < count($ret); $i++) echo "RET[$i] = (".$ret[$i]."), ";
 echo "<br>\n";
 }
 }

 return $ret;
}













































function perm_type_for_folder($folder_id, $mother = null) {
 
 if (is_null($mother)) {
 $folder = get_folderinfo($folder_id); 
 $mother = $folder["mother"];
 }
 return (0 == $mother) ? T_NODE : T_FOLDER;
}












function perm($user_id,$o_type,$o_id="",$bit=-1,$contentgroup_id=NULL,$checktype=NULL,$roleperm_bit=-1, $nodeId = 0) {

 $has_perm = _perm_internal($user_id, $o_type, $o_id, $bit, $contentgroup_id, $checktype, $roleperm_bit, $nodeId);
 if ($has_perm) {
 return $has_perm;
 }

 if ($o_type == T_FOLDER) {
 
 
 $corrected_o_type = perm_type_for_folder($o_id);
 if ((int)$corrected_o_type != (int)$o_type) {
 return _perm_internal($user_id, $corrected_o_type, $o_id, $bit, $contentgroup_id, $checktype, $roleperm_bit, $nodeId); 
 }
 }

 return false;
}

function _perm_internal($user_id,$o_type,$o_id="",$bit=-1,$contentgroup_id=NULL,$checktype=NULL,$roleperm_bit=-1, $nodeId = 0) {
 global $USER_PERM, $DEBUG, $PERM, $FEATURE, $T_FOLDER, $CN_LOCAL_SERVER, $PORTLETAPP_PREFIX_INTERNAL, $NODE_ID, $SESSION_TOKEN;

 if (!$user_id) {
 if ($bit == -1) {
 return array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0);
 } else {
 return 0;
 }
 }

 if ($user_id == 1) {
 
 if ($bit == -1) { 
 if (isset($PERM) && is_array($PERM[$o_type])) {
 
 $res = array();
 reset($PERM[$o_type]);
 while (list($key,$val) = each($PERM[$o_type])) {
 $res[$key] = 1;
 }
 return $res;
 } else return array(1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1);
 } else return 1;
 }

 if ($o_id == "") $o_id = -1;

 if ($nodeId == 0) {
 $nodeId = $NODE_ID;
 }

 
 $cachekey = $o_type."|".$o_id."|".$nodeId;
 $ret = $GLOBALS["REST_PERM_CACHE"][$cachekey];

 if (!$ret) {
 
 $o_type = intval($o_type);
 $o_id = intval($o_id);
 $response = getFromREST("/perm/$o_type/$o_id", $nodeId ? array("nodeId" => $nodeId) : null);
 $ret = $response["perm"];
 $GLOBALS["REST_PERM_CACHE"][$cachekey] = $ret;
 }

 if ($bit >= 0) {
 $ret = $ret[$bit];
 }

 
 if( $FEATURE['roles'] ) {
 if( $bit != -1 && $ret ) return $ret;
 if( is_numeric($contentgroup_id) || $checktype !== NULL ) {
 $perm = perm_for_object_and_contentgroup($user_id, $o_type, $o_id, $checktype, $contentgroup_id);
 if( $roleperm_bit != -1 ) return $perm[$roleperm_bit];
 $ret = perm_join_permarrays( $ret, $perm );
 }
 }

 return $ret;
}





function perm_group($group_id,$o_type,$o_id="",$bit=-1,$contentgroup_id=NULL,$checktype=NULL,$roleperm_bit=-1) {
 global $GROUP_PERM, $FEATURE;

 if (!$group_id) halt(7,"perm_group: No group_id! group_id($group_id).");
 if (!$o_type) halt(7,"perm_group: No o_type! o_type($o_type).");

 if ($o_id == "") $o_id = -1;
 if ($o_id != -1) $WHERE = " AND perm.o_id = \"".sqlslashes($o_id)."\"";

 $sql = "SELECT perm FROM perm WHERE perm.o_type = ".sqlf_tl_num($o_type)."$WHERE AND perm.usergroup_id = ".sqlf_tl_num($group_id);

 $ret = private_perms($GROUP_PERM,$sql,$group_id,$o_type,$o_id,$bit);
 
 if( $FEATURE['roles'] ) {
 if( $bit != -1 && $ret ) return $ret;
 if( $contentgroup_id !== NULL || $checktype !== NULL ) {
 
 $perm = perm_for_object_and_contentgroup( NULL, $o_type, $o_id, $checktype, $contentgroup_id, $group_id );
 if( $roleperm_bit != -1 ) return $perm[$roleperm_bit];
 $ret = perm_join_permarrays( $ret, $perm );
 }
 }

 return $ret;
}


$USERGROUP_PERM = array();

function perm_usergroup($user_id,$group_id,$bit=-1,$roots = false) {
 global $USERGROUP_PERM, $T_GROUPADMIN, $DEBUG;

 if ($user_id == 1) {
 
 if ($bit == -1) { 
 if (isset($PERM) && is_array($PERM[$o_type])) {
 $res = array();
 reset($PERM[$type]);
 while (list($key,$val) = each($PERM[$o_type])) {
 $res[$key] = 1;
 }
 return $res;
 } else return array(1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1);
 } else return 1;
 }

 if ($DEBUG["perm"])
 echo "perm_usergroup($user_id,$group_id,$bit)<br>";
 
 if (!$user_id || !$group_id) halt(7,"perm_usergroup: No userid or groupid! USER_ID($user_id) GROUP_ID($group_id)");

 if (is_array($USERGROUP_PERM[$user_id][$group_id][$roots])) {
 $res = $USERGROUP_PERM[$user_id][$group_id][$roots];
 } else {
 
 $sql = "SELECT usergroup_id FROM user_group WHERE user_id = ".sqlf_tl_num($user_id);
 $rs = query($sql,true);
 if ($rs["arr"]) {
 while (list($key,$val) = each($rs["arr"])) {
 $groups[] = $val["usergroup_id"];
 }
 }

 $nowgroup = $group_id;
 while ($nowgroup > 0) {
 if (in_array($nowgroup,$groups)) $highgroup = $nowgroup;
 $sql = "SELECT mother FROM usergroup WHERE id = ".sqlf_tl_num($nowgroup);
 $rs = query($sql,true);
 $nowgroup = $rs["arr"][0]["mother"];
 }

 $sql = "SELECT perm FROM perm WHERE usergroup_id = ".sqlf_tl_num($highgroup)." AND o_type = ".sqlf_tl_num($T_GROUPADMIN);
 $rs = query($sql,true);
 $perm = $rs["arr"][0]["perm"];

 if (ereg("^[0-1]*$",$perm)) {
 $c = strlen($perm);

 for ($j = 0; $j < $c; $j++) {
 $set = substr($perm,$j,1);
 
 if ($roots && $highgroup == $group_id && $j > 7) {
 $set = 0;
 }
 if (!isset($res[$j])) $arr[$j] = 0;
 $res[$j] = max($set,$res[$j]);
 } 
 }

 $USERGROUP_PERM[$user_id][$group_id][$roots] = $res;
 }

 if ($bit > -1) {
 if ($bit >= count($res)) $ret = 0; else $ret = $res[$bit]; 
 } else $ret = $res;

 return $ret;
}






function duplicate_perm($source_type, $source_id, $target_type, $target_id) {

 global $USER_PERM,$GROUP_PERM,$USERGROUP_PERM, $DUPLICATE_PERM, $FEATURE;

 node_include("PERM");

 
 $sql = "SELECT usergroup_id FROM perm WHERE o_type = ".sqlf_tl_num($source_type)." AND o_id = \"".sqlslashes($source_id)."\"";
 $rs = query($sql,1);

 if ($rs["num"]) {
 $sql1 = "DELETE FROM perm WHERE o_type = ".sqlf_tl_num($target_type)." AND o_id = \"".sqlslashes($target_id)."\"";
 query($sql1);
 
 
 $sqlpart = "";
 for ($i = 0; $i < $rs["num"]; $i++) {
 $perm = perm2string(convert_perm($rs["arr"][$i]["usergroup_id"],$source_type, $source_id, $target_type, $target_id));
 if ($sqlpart) $sqlpart .= ",";
 $sqlpart .= "(".sqlf_tl_num($rs["arr"][$i]["usergroup_id"]).",'".sqlf_escaped($perm)."',".sqlf_tl_num($target_type).",\"".sqlslashes($target_id)."\")";
 }
 if ($sqlpart) {
 $sql = "INSERT INTO perm (usergroup_id, perm, o_type, o_id) VALUES $sqlpart";
 query($sql);
 }
 }
 
 if( $FEATURE['roles'] ) {
 
 $sql = "SELECT role_usergroup_assignment.role_usergroup_id,role_usergroup.usergroup_id,role_usergroup.role_id FROM role_usergroup INNER JOIN role_usergroup_assignment ON role_usergroup.id = role_usergroup_assignment.role_usergroup_id WHERE role_usergroup_assignment.obj_type = '".sqlf_escaped($source_type)."' AND role_usergroup_assignment.obj_id = '".sqlf_escaped($source_id)."'";
 $rs = query( $sql );
 foreach( $rs['arr'] as $row ) {
 $usergroup_id = $row['usergroup_id'];
 $role_id = $row['role_id'];
 
 $sql = "SELECT id FROM role_usergroup WHERE role_id = ".sqlf_tl_num($role_id)." AND usergroup_id = ".sqlf_tl_num($usergroup_id);
 $role_usergrouprs = query($sql);
 $role_usergroup_id = null;
 if( $role_usergrouprs['num'] > 0 ) {
 $role_usergroup_id = $role_usergrouprs['arr'][0]['id'];
 } else {
 $sql = "INSERT INTO role_usergroup (role_id,usergroup_id) VALUES (".sqlf_tl_num($role_id).", ".sqlf_tl_num($usergroup_id).")";
 $role_usergrouprs = query( $sql );
 $role_usergroup_id = $role_usergrouprs['iid'];
 }

 
 $sql = "INSERT INTO role_usergroup_assignment (role_usergroup_id, obj_id, obj_type) values (".sqlf_tl_num($role_usergroup_id).", ".sqlf_tl_num($target_id).", ".sqlf_tl_num($target_type).")";
 query( $sql );
 }
 }
 
 unset($USER_PERM[$target_type][$target_id]);
 unset($GROUP_PERM[$target_type][$target_id]);
 $USERGROUP_PERM = array();

 
 node_include("codeparser");
 $javaParser =& CodeParser::getJavaParser();
 $javaParser->refreshPerms($target_type, $target_id);
}





function duplicate_group_perm($source_id, $target_id) {

 global $USER_PERM,$GROUP_PERM,$USERGROUP_PERM,$FEATURE;

 
 
 
 
 $sql = "SELECT o_type, o_id, perm FROM perm WHERE usergroup_id = ".sqlf_tl_num($source_id);
 $rs = query($sql);

 if ($rs["num"]) {
 $sql1 = "DELETE FROM perm WHERE usergroup_id = ".sqlf_tl_num($target_id);
 query($sql1);

 
 for ($i = 0; $i < $rs["num"]; $i++) {
 
 
 $perm = $rs["arr"][$i]["perm"];
 $sql = "INSERT INTO perm (usergroup_id, perm, o_type, o_id) VALUES (".sqlf_tl_num($target_id).",'".sqlf_escaped($perm)."',".sqlf_tl_num($rs["arr"][$i]["o_type"]).",\"".sqlslashes($rs["arr"][$i]["o_id"])."\")";
 query($sql);
 }
 }

 if( $FEATURE['roles'] ) {
 
 
 
 $sql = "SELECT id FROM role_usergroup WHERE usergroup_id = ".sqlf_tl_num($target_id);
 $rs = query( $sql );
 foreach( $rs['arr'] as $row ) {
 $sql = "DELETE FROM role_usergroup_assignment WHERE role_usergroup_id = ". sqlf_tl_num($row['id']);
 query( $sql );
 }
 $sql = "DELETE FROM role_usergroup WHERE usergroup_id = ".sqlf_tl_num($target_id);
 query( $sql );

 
 $sql = "SELECT id, role_id FROM role_usergroup WHERE usergroup_id = ".sqlf_tl_num($source_id);
 $rs = query( $sql );
 foreach( $rs['arr'] as $row ) {
 $sql = "INSERT INTO role_usergroup (role_id, usergroup_id) values ('".sqlf_escaped($row['role_id'])."','".sqlf_escaped($target_id)."')";
 $newrs = query( $sql );
 $newid = $newrs['iid'];
 $sql = "SELECT obj_id, obj_type FROM role_usergroup_assignment WHERE role_usergroup_id = ".sqlf_tl_num($row['id']);
 $assignrs = query( $sql );
 foreach( $assignrs['arr'] as $assignrow ) {
 $sql = "INSERT INTO role_usergroup_assignment (role_usergroup_id, obj_id, obj_type) VALUES ('".sqlf_escaped($newid)."','".sqlf_escaped($assignrow['obj_id'])."','".sqlf_escaped($assignrow['obj_type'])."')";
 query( $sql );
 }
 }
 }

 $USER_PERM = array();
 $GROUP_PERM = array();
 $USERGROUP_PERM = array();

 
 node_include("codeparser");
 $javaParser =& CodeParser::getJavaParser();
 $javaParser->refreshGroupPerms($target_id);
}




function convert_perm ($group, $source_type, $source_id, $target_type, $target_id) {
 global $PERM;

 
 $source_perm = $PERM[$source_type];
 $target_perm = $PERM[$target_type];
 
 
 if (!is_array($target_perm)) return array();
 if (!is_array($source_perm)) $source_perm = array();
 
 if ($source_type == $target_type) {
 $perm = perm_group($group, $source_type, $source_id);
 return $perm;
 }
 
 ksort($target_perm);

 
 reset($target_perm);
 while (list($target_bit, $target) = each($target_perm)) {
 $bit_exists = false;

 
 if ($target_bit < 8) {
 $bit_exists = true;
 $source_bit = $target_bit;
 } else {
 
 reset($source_perm);
 while (list($source_bit,$source) = each($source_perm)) {
 
 if (($target["group"] == $source["group"]) && ($target["short"] == $source["short"])) { 
 $bit_exists = true;

 break;
 }
 }
 }

 
 if ($bit_exists) {
 $perm[$target_bit] = perm_group($group, $source_type, $source_id, $source_bit);
 } else {
 $perm[$target_bit] = perm_group($group, $target_type, $target_id, $target_bit); 
 }
 }
 
 return $perm;
}

function perm2string($perm) {

 $_perm = "";
 
 $lastbit=0;
 for ($i = 0; $i < 32; $i++) {
 
 $_perm .= "".($perm[$i])?"1":"0";
 }
 return $_perm;
}

function string2perm($permstr) {
 $c = strlen( $permstr );
 $perm = array( );
 for ($i = 0 ; $i < $c ; $i++) {
 $perm[$i] = $permstr[$i];
 }
 return $perm;
}




function perm_get_visibility($group_id,$o_type,$o_id) {
 global $T_TYPE;


 return 1;
}


function perm_set_visibility($group_id,$o_type,$o_id) {
 global $T_TYPE;

}


function perm_setperms($group_id,$source_type,$source_id,$ntype,$nid,$rowvals = "") {
 global $T_TYPE, $PERMSQL, $USER_ID;

 
 $childs = tree_get_subfolders($ntype, $nid, "", $rowvals);

 if ($childs) {
 while (list($key,$val) = each($childs)) {
 
 $o_type = $val["type"];
 $o_id = $val["id"];
 if ($o_id == 0) {
 continue;
 }
 
 
 
 if (perm($USER_ID,$o_type,$o_id,1) && perm_usergroup($USER_ID,$group_id,13)) {
 $perm = perm2string(convert_perm($group_id,$source_type,$source_id,$o_type,$o_id));
 perm_set_perms($group_id,$o_type,$o_id,$perm);
 }
 perm_setperms($group_id,$source_type,$source_id,$o_type,$o_id,$val["val"]);
 }
 }
}


function perm_set_recursiveperms($group_id,$o_type,$o_id) {
 global $PERM_ROWVAL;

 set_time_limit(0);

 node_include("get_group_perm");

 node_func("tree_get_subfolders"); 
 perm_setperms($group_id,$o_type,$o_id,$o_type,$o_id, $PERM_ROWVAL);
}




function perm_get_lockedbits($group_id) {
 global $T_GROUPADMIN;
 
 if (!$group_id) halt(7,"perm_get_neededbits: no group_id");
 
 
 $sql = "SELECT mother FROM usergroup WHERE id = ".sqlf_tl_num($group_id);
 $rs = query($sql,1);

 $mother = $rs["arr"][0]["mother"];
 if (!$mother) return Array();

 $perm = perm_group($mother,$T_GROUPADMIN);

 while (list($key,$val) = each($perm)) {
 if (!$val) $res[] = $key;
 }

 return $res;
}


function perm_get_neededbits($group_id) {
 global $T_GROUPADMIN;

 
 $sql = "SELECT id FROM usergroup WHERE mother = ".sqlf_tl_num($group_id);
 $rs = query($sql,1);

 $res = array();

 if ($rs["arr"]) {
 while (list($key1,$val1) = each($rs["arr"])) {
 $perm = perm_group($val1["id"],$T_GROUPADMIN);
 
 while (list($key,$val) = each($perm)) {
 if ($val && !in_array($key,$res)) $res[] = $key;
 }
 }
 }

 return $res;
}


function perm_set_groupbit($group_id,$bit,$value) {
 global $T_GROUPADMIN;
 
 if (!$group_id) halt(7,"perm_set_groupbit: No Group_id!");
 if ($value != 0 && $value != 1) halt(7,"perm_set_groupbit: Invalid Bitvalue VALUE($value)");
 
 
 $sql = "SELECT perm,o_id FROM perm WHERE usergroup_id = ".sqlf_tl_num($group_id)." AND o_type = ".sqlf_tl_num($T_GROUPADMIN);
 $rs = query($sql);
 
 $perm = $rs["arr"][0]["perm"];
 $o_id = $rs["arr"][0]["o_id"];
 
 
 
 if (strlen($perm) < ($bit + 1)) { 
 $perm .= str_repeat("0", $bit + 1 - strlen($perm)); 
 } 
 
 
 $perm = substr($perm,0,$bit).$value.substr($perm,$bit+1);

 
 perm_set_perms($group_id,$T_GROUPADMIN,$o_id,$perm);
 
 
 $sql = "SELECT id FROM usergroup WHERE mother = ".sqlf_tl_num($group_id);
 $rs = query($sql,1);

 
 if ($rs["arr"]) {
 while (list($key,$val) = each($rs["arr"])) {
 perm_set_groupbit($val["id"],$bit,$value);
 }
 }
}



function perm_getusergroups($o_type, $o_id, $bit, $value = 1, $user_id = -1) {
 
 if (is_array($bit)) return array();

 $perm_mask = "";
 for ($i = 0; $i < PERMSTRING_LENGTH; $i++) {
 if ($i == $bit) $perm_mask .= $value;
 else $perm_mask .= '_';
 }
 $o_id_where = $o_id > -1 ? (" o_id = '".sqlf_escaped($o_id)."' AND ") : " ";
 if($user_id == -1 ) {
 $sql = 'SELECT usergroup_id FROM perm WHERE '.$o_id_where.' o_type = '.sqlf_tl_num($o_type).' AND perm LIKE "'.sqlf_escaped($perm_mask).'"';
 } else {
 $sql = 'SELECT perm.usergroup_id FROM perm JOIN user_group ON perm.usergroup_id=user_group.usergroup_id WHERE '.$o_id_where.' o_type='.sqlf_tl_num($o_type).' AND user_id='.sqlf_tl_num($user_id).' AND perm LIKE "'.sqlf_escaped($perm_mask).'"';
 }
 $rs = query($sql);
 $ret = reduce_array($rs["arr"],"usergroup_id","usergroup_id");
 return $ret;
}









function perm_for_object_and_contentgroup($user_id, $obj_type, $obj_id, $checktype, $contentgroup_id = 0, $group_id = NULL) {
 global $T_CONTENTGROUP, $FEATURE;
 if( ! $FEATURE['roles'] ) {
 return false;
 }
 if (!$contentgroup_id) {
 $contentgroup_id = 0;
 }
 
 
 $sql = "SELECT roleperm.perm,roleperm_obj.obj_type,roleperm_obj.obj_id";
 $sql .= " , roleperm_obj_cg.obj_id AS roleperm_obj_cg_obj_id ";
 if( $group_id === NULL ) {
 $sql .= "
FROM user_group 
  INNER JOIN role_usergroup ON role_usergroup.usergroup_id = user_group.usergroup_id ";
 } else {
 $sql .= "
FROM role_usergroup ";
 }
 $sql .= "
  INNER JOIN role_usergroup_assignment 
      ON role_usergroup_assignment.role_usergroup_id = role_usergroup.id 
      AND role_usergroup_assignment.obj_type = ".sqlf_tl_num($obj_type)." 
      AND role_usergroup_assignment.obj_id = ".sqlf_tl_num($obj_id)." 
  INNER JOIN role ON role.id = role_usergroup.role_id
  INNER JOIN roleperm ON roleperm.role_id = role.id
  INNER JOIN roleperm_obj
      ON roleperm_obj.roleperm_id = roleperm.id
      AND roleperm_obj.obj_type = ".sqlf_tl_num($checktype)." AND roleperm_obj.obj_id IS NULL
  LEFT JOIN roleperm_obj AS roleperm_obj_cg
      ON roleperm_obj_cg.roleperm_id = roleperm.id
      AND roleperm_obj_cg.obj_type = ".sqlf_tl_num($T_CONTENTGROUP)." ";
 if( $group_id === NULL ) {
 $sql .= " WHERE user_group.user_id = ".sqlf_tl_num($user_id)." ";
 } else {
 $sql .= " WHERE role_usergroup.usergroup_id = ".sqlf_tl_num($group_id)." ";
 }
 $sql .= "	AND (roleperm_obj_cg.obj_id = ".sqlf_tl_num($contentgroup_id)."
		 OR roleperm_obj_cg.obj_id IS NULL)";

 $rs = query( $sql );
 $allperm = array( );
 foreach( $rs['arr'] as $row ) {
 $perm = string2perm( $row['perm'] );
 $allperm = perm_join_permarrays( $allperm, $perm );
 }
 return $allperm;
}

function perm_join_permarrays( $perm1, $perm2 ) {
 $perm = array();
 for( $i = 0 ; $i < max( count($perm1), count($perm2) ) ; $i++) {
 $perm[$i] = $perm1[$i] || $perm2[$i];
 }
 return $perm;
}








function perm_hasfolderviewpermissions($user_id, $folder_id, $type) {
 global $T_FOLDER;
 $folder_type = $T_FOLDER;
 $perm = perm_for_object_and_contentgroup($user_id, $folder_type, $folder_id, $type);
 if( $perm[10] ) return true;
 $sql = "SELECT contentgroup_id FROM folder INNER JOIN node_contentgroup ON node_contentgroup.node_id = folder.node_id WHERE folder.id = ".sqlf_tl_num($folder_id);
 $rs = query( $sql );
 foreach( $rs['arr'] as $row ) {
 $perm = perm_for_object_and_contentgroup($user_id, $folder_type, $folder_id, $type, $row['contentgroup_id'] );
 if( $perm[10] ) return $row['contentgroup_id'];
 }
 return false;
}




function perm_check_for_all_contentgroups($user_id, $folder_id, $page_id, $permbit, $rolepermbit) {
 global $T_FOLDER, $T_PAGE;
 $sql = "SELECT allpages.contentgroup_id, allpages.folder_id FROM page LEFT JOIN page AS allpages ON allpages.contentset_id = page.contentset_id and (allpages.id = page.id || allpages.contentset_id <> 0) WHERE page.id = ".sqlf_tl_num($page_id);
 $rs = query($sql);
 if( $rs['num'] < 1 ) return false;
 foreach( $rs['arr'] as $row ) {
 if(!perm( $user_id, $T_FOLDER, $row["folder_id"], $permbit, $row['contentgroup_id'], $T_PAGE, $rolepermbit )) {
 return false;
 }
 }
 return true;
}









function perm_update_roles( $group_id, $obj_type, $obj_id, $roles, $recursive = FALSE) {
 global $PERM_ROWVAL, $T_FOLDER, $T_DOMAIN;

 if( $recursive ) {
 
 $childs = tree_get_subfolders($obj_type, $obj_id, "", $PERM_ROWVAL); 

 if ($childs) {
 while (list($key,$val) = each($childs)) {
 
 $o_type = $val["type"];
 $o_id = $val["id"];
 perm_update_roles( $group_id, $o_type, $o_id, $roles, TRUE );
 }
 }
 }


 $oldroles_ = perm_roles_get_of_group( $group_id, $obj_type, $obj_id );
 $oldroles = reduce_array( $oldroles_, 'role_id', 'role_id' );
 $allroles = perm_roles_get_all();

 foreach( $allroles as $role ) {
 $role_id = $role['role_id'];
 $val = in_array( $role_id, $roles ) ? 1 : 0;
 $oldval = $oldroles[ $role_id ] ? 1 : 0;
 $role_usergroup_id = null;
 
 
 if( intval($oldval) !== intval($val) ) {
 $sql = "SELECT id FROM role_usergroup WHERE usergroup_id = ".sqlf_tl_num($group_id)." AND role_id = '".sqlf_escaped($role_id)."'";
 $role_usergroup_rs = query( $sql );
 if( $role_usergroup_rs['num'] > 0 ) {
 $role_usergroup_id = $role_usergroup_rs['arr'][0]['id'];
 }
 if( $val ) {
 
 if( $role_usergroup_id === null ) {
 
 $sql = "INSERT INTO role_usergroup (role_id, usergroup_id) VALUES ('".sqlf_escaped($role_id)."', ".sqlf_tl_num($group_id).")";
 $role_rs = query( $sql );
 $role_usergroup_id = $role_rs['iid'];
 }
 $sql = "INSERT INTO role_usergroup_assignment (role_usergroup_id, obj_type, obj_id) VALUES ('".sqlf_escaped($role_usergroup_id)."', '".sqlf_escaped($obj_type)."', '".sqlf_escaped($obj_id)."')";
 query( $sql );
 } else {
 $sql = "DELETE FROM role_usergroup_assignment WHERE role_usergroup_id = ".sqlf_tl_num($role_usergroup_id)." AND obj_type = ".sqlf_tl_num($obj_type)." AND obj_id = ".sqlf_tl_num($obj_id);
 query( $sql );
 }
 }
 }

 node_include("codeparser");
 $javaParser =& CodeParser::getJavaParser();
 $javaParser->refreshPerms($obj_type, $obj_id);
}






function perm_remove_perms($objType, $objId) {
 $sql = "DELETE FROM perm WHERE o_type = ".sqlf_tl_num($objType). " AND o_id = ".sqlf_tl_num($objId);
 query($sql);

 node_include("codeparser");
 $javaParser =& CodeParser::getJavaParser();
 $javaParser->refreshPerms($objType, $objId);
}





function perm_roles_get_all( ) {
 $sql = "SELECT role.id AS role_id FROM role";
 $rs = query( $sql );
 return $rs['arr'];
}




function perm_roles_get_of_group( $group_id, $obj_type, $obj_id ) {
 $sql = "SELECT role_usergroup.role_id FROM role_usergroup INNER JOIN role_usergroup_assignment ON role_usergroup_assignment.role_usergroup_id = role_usergroup.id WHERE role_usergroup.usergroup_id = ".sqlf_tl_num($group_id)." AND role_usergroup_assignment.obj_type = ".sqlf_tl_num($obj_type)." AND role_usergroup_assignment.obj_id = ".sqlf_tl_num($obj_id);
 $rs = query( $sql );
 return $rs['arr'];
}





function perm_can_view_construct($construct_id) {
 global $USER_ID;
 
 return $USER_ID == 1 || perm($USER_ID, T_CONSTRUCTS, "", 2);
}




function perm_can_view_page($page_id) {
 global $USER_ID;
 $page = get_pageinfo($page_id);
 
 return $USER_ID == 1 || perm($USER_ID, T_FOLDER, $page["folder_id"], 11, $page['contentgroup_id'], T_PAGE, 10);
}





function perm_can_edit_page($page_id) {
 global $USER_ID;
 $page = get_pageinfo($page_id);
 
 return $USER_ID == 1 || perm($USER_ID, T_FOLDER, $page["folder_id"], 13, $page['contentgroup_id'], T_PAGE, 12);
}






function perm_can_view_folder($folder_id) {
 global $USER_ID;
 
 return $USER_ID == 1 || perm($USER_ID, T_FOLDER, $folder_id, 0, null, T_FOLDER, 10);
}






function perm_can_edit_folder($folder_id) {
 
 return perm_check_folder($folder_id, 9, 12);
}






function perm_can_delete_folder($folder_id) {
 
 return perm_check_folder($folder_id, 10, 13);
}












function perm_can_delete_folder_tree($id) {
 global $USER_ID,$T_FOLDER;

 if (perm($USER_ID, $T_FOLDER, $id, 10)) {
 $allow = true;
 $sql = "SELECT id FROM folder WHERE mother = ".sqlf_tl_num($id);
 $rs = query($sql,1);
 
 if ($rs["arr"]) {
 while (list($key,$val) = each($rs["arr"])) {
 $allow = $allow && perm_can_delete_folder_tree($val["id"]);
 }
 }
 
 return $allow;
 } else {
 return false;
 }
}









function perm_can_delete_folder_root($folder_id) {
 if ( ! perm_can_delete_folder($folder_id) ) {
 return false;
 }
 return perm_can_delete_folder_tree($folder_id);
}







function perm_check_folder($folder_id, $perm, $role_perm) {
 global $USER_ID;
 $folder = get_folderinfo($folder_id);
 $mother = $folder["mother"];
 if ( ! $mother) {
 $mother = $folder_id;
 }
 return $USER_ID == 1 || perm($USER_ID, T_FOLDER, $mother, $perm, null, T_FOLDER, $role_perm);
}






function perm_check_template($template_id, $permbit, $role_perm, $folder_id = null) {
 global $USER_ID, $FEATURE;
 if ($FEATURE["multichannelling"]) {
 
 $template_id = getMasterTemplateId($template_id);
 if ($folder_id) {
 $folder_id = getMasterFolderId($folder_id);
 }
 }
 $sql = "SELECT folder_id FROM template_folder"
 . " WHERE template_id = ".sql_num($template_id);
 
 if ($folder_id) {
 $sql .= " AND folder_id = ".sql_num($folder_id);
 }
 $rs = query($sql);
 foreach ($rs["arr"] as $row) {
 if (perm($USER_ID, T_FOLDER, $row["folder_id"], $permbit, null, T_TEMPLATE, $role_perm)) {
 return true;
 }
 }
 
 
 return $USER_ID == 1;
}





function perm_can_view_template($template_id, $folder_id = null) {
 
 return perm_check_template($template_id, 15, 10, $folder_id);
}




function perm_can_view_folder_templates($folder_id) {
 global $USER_ID;
 
 return $USER_ID == 1 || perm($USER_ID, T_FOLDER, $folder_id, 15, null, T_TEMPLATE, 10);
}





function perm_can_edit_template($template_id, $folder_id = null) {
 
 return perm_check_template($template_id, 17, 12, $folder_id);
}





function perm_can_create_templates($folder_id) {
 global $USER_ID;
 
 return $USER_ID == 1 || perm($USER_ID, T_FOLDER, $folder_id, 16, null, T_TEMPLATE, 11);
}















function perm_can_create_pages($folder_id, $contentgroup_id) {
 global $USER_ID;
 
 return $USER_ID == 1 || perm($USER_ID, T_FOLDER, $folder_id, 12, $contentgroup_id, T_PAGE, 11);
}















function perm_can_create_page_or_translation($folder_id, $contentgroup_id) {
 global $USER_ID;
 
 return $USER_ID == 1 || perm_can_create_pages($folder_id, $contentgroup_id) || perm($USER_ID, T_FOLDER, $folder_id, 12, $contentgroup_id, T_PAGE, 15);
}




function perm_can_delete_page($page_id) {
 global $USER_ID;
 $page = get_pageinfo($page_id);
 
 return $USER_ID == 1 || perm($USER_ID, T_FOLDER, $page["folder_id"], 14, $page['contentgroup_id'], T_PAGE, 13);
}






function perm_can_move_page($page_id) {
 global $FEATURE;
 if ($FEATURE["move_perm_with_edit"]) {
 return perm_can_edit_page($page_id);
 } else {
 return perm_can_delete_page($page_id);
 }
}





function perm_can_create_files($folder_id) {
 global $USER_ID;
 
 return $USER_ID == 1 || perm($USER_ID, T_FOLDER, $folder_id, 12, null, CT_FILE, 11);
}






function perm_can_edit_file($file_id) {
 global $USER_ID;
 $file = get_fileinfo($file_id);
 
 return $USER_ID == 1 || perm($USER_ID, T_FOLDER, $file["folder_id"], 13, null, CT_FILE, 12);
}






function perm_can_delete_file($file_id) {
 global $USER_ID;
 $file = get_fileinfo($file_id);
 return $USER_ID == 1 || perm($USER_ID, T_FOLDER, $file["folder_id"], 14, null, CT_FILE, 13);
}






function perm_can_move_file($file_id) {
 global $FEATURE;
 if ($FEATURE["move_perm_with_edit"]) {
 return perm_can_edit_file($file_id);
 } else {
 return perm_can_delete_file($file_id);
 }
}





function perm_can_view_file($file_id) {
 global $USER_ID;
 $file = get_fileinfo($file_id);
 
 return $USER_ID == 1 || perm($USER_ID, T_FOLDER, $file["folder_id"], 11, null, CT_FILE, 10);
}




function perm_can_view($obj_type, $obj_id) {
 if (T_FOLDER == $obj_type) {
 return perm_can_view_folder($obj_id);
 }
 elseif (T_PAGE == $obj_type) {
 return perm_can_view_page($obj_id);
 }
 elseif (T_TEMPLATE == $obj_type) {
 return perm_can_view_template($obj_id);
 }
 elseif (CT_FILE == $obj_type || T_IMAGE == $obj_type) {
 return perm_can_view_file($obj_id);
 }
 else {
 halt(7, "Unrecoginzed type: " . $obj_type);
 }
}




function perm_can_edit($obj_type, $obj_id) {
 if (T_FOLDER == $obj_type) {
 return perm_can_edit_folder($obj_id);
 }
 elseif (T_PAGE == $obj_type) {
 return perm_can_edit_page($obj_id);
 }
 elseif (T_TEMPLATE == $obj_type) {
 return perm_can_edit_template($obj_id);
 }
 elseif (CT_FILE == $obj_type || T_IMAGE == $obj_type) {
 return perm_can_edit_file($obj_id);
 }
 else {
 halt(7, "Unrecoginzed type: " . $obj_type);
 }
}




function perm_can_view_objtag($objtag_id, $obj_type, $obj_id) {
 global $USER_ID;

 return $USER_ID == 1
 
 || ( perm_objtag($objtag_id, $obj_type, 0)
 && perm_can_view($obj_type, $obj_id));
}







function perm_can_edit_objtag($objtag_id, $obj_type, $obj_id) {
 global $USER_ID;

 if (T_FOLDER == $obj_type) {
 
 
 $obj_perm = perm($USER_ID, T_FOLDER, $obj_id, 9, null, T_FOLDER, 12);
 }
 else {
 $obj_perm = perm_can_edit($obj_type, $obj_id);
 }

 
 return $USER_ID == 1 || ($obj_perm && perm_objtag($objtag_id, $obj_type, 2));
}






function perm_objtag($objtag_id, $obj_type, $permbit) {
 return perm_objtag_row_internal($obj_type, array("intag" => $objtag_id), $permbit);
}




function perm_objtag_row_internal($obj_type, $row, $permbit, $nestedchecked = null) {
 global $USER_ID;

 
 if ($row["intag"]) {
 
 if (is_array($nestedchecked) && in_array($row["intag"], $nestedchecked)) {
 return true;
 }
 
 $sql = "select objtag.id, objtag.intag, defobjtag.id AS defobjtag_id, objtagpage.id AS objtagpage_id,objtagtemplate.id AS objtagtemplate_id,objtagfolder.id AS objtagfolder_id from objtag
LEFT JOIN objtag AS defobjtag ON defobjtag.name = objtag.name AND defobjtag.obj_id = 0 AND defobjtag.obj_type = objtag.obj_type
LEFT JOIN objtag AS objtagpage ON (objtagpage.name = objtag.name AND objtagpage.obj_id = 0 AND objtagpage.obj_type = 10007)
LEFT JOIN objtag AS objtagtemplate ON (objtagtemplate.name = objtag.name AND objtagtemplate.obj_id = 0 AND objtagtemplate.obj_type = 10006)
LEFT JOIN objtag AS objtagfolder ON (objtagfolder.name = objtag.name AND objtagfolder.obj_id = 0 AND objtagfolder.obj_type = 10002) WHERE objtag.id = ".sql_num($row["intag"]);
 $outer = query($sql);
 if ($outer["num"] > 0) {
 
 $nestedchecked[] = $outer["arr"][0]["id"];
 return perm_objtag_row_internal($obj_type, $outer["arr"][0], $permbit, $nestedchecked);
 } else {
 
 return true;
 }
 }
 
 if( $obj_type != T_PAGE ) {
 
 
 return perm( $USER_ID, T_OBJPROPELEMENT, $row['defobjtag_id'], $permbit );
 } else {
 
 
 if( !$row['objtagpage_id'] || !perm( $USER_ID, T_OBJPROPELEMENT, $row['objtagpage_id'], $permbit ) ) {
 if ( !$row['objtagtemplate_id'] || !perm( $USER_ID, T_OBJPROPELEMENT, $row['objtagtemplate_id'], $permbit ) ) {
 if ( !$row['objtagfolder_id'] || !perm( $USER_ID, T_OBJPROPELEMENT, $row['objtagfolder_id'], $permbit ) ) {
 
 return false;
 }
 }
 }
 return true;
 }
 return false;
}

?>
